<?php




function word($word,$info = 99,$output_id = 0, $lang = 0) {

if (!$lang) { 
 global $LANGUAGE;
 $lang = $LANGUAGE;
}

if ($output_id == 0) {
 $sql = "INSERT INTO outputuser (info) VALUES (".sqlf_tl_num($info).")";
 $rs = query($sql);
 $output_id = $rs["iid"];
} else {
 $sql = "UPDATE outputuser SET info = ".sqlf_tl_num($info)." WHERE id = ".sqlf_tl_num($output_id);
 query($sql);
}

$sql = "SELECT language.id, count(dicuser.output_id) AS c FROM language LEFT JOIN dicuser ON language.id = dicuser.language_id AND dicuser.output_id = ".sqlf_tl_num($output_id)." GROUP BY language.id";
$rs = query($sql,1);

$noupdate = false;
$sqlpart = "";
while (list($key,$l) = each($rs["arr"])) {
 $id = $l["id"];
 $num = $l["c"];
 if ($num == 0) {
 if ($sqlpart) $sqlpart .= ",";
 $sqlpart .= "('".sqlslashes($word)."',".sqlf_tl_num($output_id).", ".sqlf_tl_num($id).")";
 if ($id == $lang) $noupdate = true;
 } else if ($num > 1) halt(0,"duplicate word for same language. word:($word), output_id($output_id), language_id($lang)");
}
if ($sqlpart) {
 $sql = "INSERT INTO dicuser (value,output_id,language_id) VALUES $sqlpart";
 query($sql);
}

if (!$noupdate) {
 $sql = "UPDATE dicuser SET value = '".sqlslashes($word)."' WHERE output_id = ".sqlf_tl_num($output_id)." AND language_id = ".sqlf_tl_num($lang);
 query($sql);
}

return $output_id;

}

function word_del($output_id) {
 $sql = "DELETE FROM dicuser WHERE output_id = ".sqlf_tl_num($output_id);
 query($sql);
 $sql = "DELETE FROM outputuser WHERE id = ".sqlf_tl_num($output_id);
 query($sql);
}

function word_copy($id) {

 if (!$id) return 0;
 
 $sql = "SELECT info FROM outputuser WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $info = $rs["arr"][0]["info"];
 if(!$info) {
 warning(20, "Inconsistency in table outputuser - no entry found for id=$id.");
 $info = 6;
 $sql = "INSERT INTO outputuser (id, info) values ('" . sqlf_escaped($id) . "','" . sqlf_escaped($info) . "')";
 query($sql);
 }
 $sql = "INSERT INTO outputuser (info) VALUES (".sqlf_tl_num($info).")";
 $rs = query($sql);

 $new_id = $rs["iid"];

 $sql = "SELECT language.id, dicuser.value FROM language, dicuser WHERE dicuser.output_id = ".sqlf_tl_num($id)." AND dicuser.language_id = language.id";
 $rs = query($sql);

 foreach($rs["arr"] as $lang) {
 $sql = "INSERT INTO dicuser (value, output_id, language_id) VALUES (\"".sqlslashes($lang["value"])."\", ".sqlf_tl_num($new_id).", ".sqlf_tl_num($lang["id"]).")";
 query($sql);
 }

 return $new_id;
}

?>
