<?php

class LabelComponent extends FormComponent
{
 function LabelComponent( $label=NULL, $text="", $isHTML=false) {
 parent::FormComponent( $label, false, true );
 $this->d_values["t"] = $text;
 $this->d_values["h"] = $isHTML;
 }

 






 function getFields() {
 return array_merge( parent::getFields(), array( "t"=>"Just plain text" ) );
 }

 function getFocusableElementName()
 {
 return NULL;
 }
 
 function toString()
 {
 return $this->d_values["t"];
 }

 function isHTML()
 {
 return $this->d_values["h"];
 }
 
 function setText($text) {
 $this->d_values["t"] = $text;
 }

 function getText() {
 return $this->d_values["t"];
 }

 function &getResultObject() {
 node_class("StringObject");
 return new StringObject($this->getText());
 }

 function setObject(&$obj) {
 $this->setText($obj->toString());
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 if ( $this->isHTML() ) {
 $text = $this->getText();
 } else {
 $text = htmlentities_utf8($this->getText());
 }
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, '') ) {
 $text = "<span ".$help["html"].">$text</span>";
 }
 return $this->mergeResult( parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $text."\n" );
 }
 
}
?>
