<?php
class FormAction extends BaseObject {
 






 function perform(& $form, $param) {
}
}

class ResolvableFormAction extends FormAction {
 




 function getName() {
}
}

class ValueSetterFormAction extends FormAction {
 var $m_propertyKey, $m_field, $m_value;

 function ValueSetterFormAction($propertyKey, $field, $value) {
 $this->m_propertyKey = $propertyKey;
 $this->m_field = $field;
 $this->m_value = $value;
 }
 
 function perform(& $form, $param) {
 node_func( "resolveproperty" );
 $fC = &resolveProperty( $this->m_propertyKey , $form);
 $fC->setFieldValue( $this->m_field, $this->m_value );
 }
}

class SimpleFormAction extends FormAction {
 var $m_funcName;
 var $m_param;
 function SimpleFormAction($funcName, $param = "") {
 $this->m_funcName = $funcName;
 $this->m_param = $param;
 }

 function perform(& $form, $param) {
 if (function_exists($this->m_funcName)) {
 $f = $this->m_funcName;
 return $f( $form, $this->m_param, $param );
 }
 }
}

class SimpleClassFormAction extends FormAction {
 var $m_funcName;
 var $m_param;
 var $m_className;
 function SimpleClassFormAction($className, $funcName, $param = "") {
 $this->m_className = $className;
 $this->m_funcName = $funcName;
 $this->m_param = $param;
 }

 function perform(& $form, $param) {
 node_class( $this->m_className );
 $f = $this->m_funcName;
 $c = $this->m_className;
 eval ( "\$ret = $c::$f( \$form, \$this->m_param, \$param );" );
 return $ret;
 }
}

class RedoFormAction extends FormAction {

 var $m_redo;
 function RedoFormAction($redo) {
 $this->m_redo = $redo;
 }

 function getRedo() {
 return $this->m_redo;
 }

 function perform( &$form, $param ) {
 global $REDO;
 $REDO = $this->m_redo;
 }

}

class SimpleResolvableFormAction extends ResolvableFormAction {
 var $m_name = "";
 var $m_param;
 function SimpleResolvableFormAction($name, $param = NULL) {
 $this->m_name = $name;
 $this->m_param = $param;
 }
 
 function getName() {
 return $this->m_name;
 }
 
 function getParam() {
 return $this->m_param;
 }
}

class ComponentResolvableFormAction extends FormAction { 
 
 var $m_propertyKey;
 var $m_name = "";
 var $m_param;

 function ComponentResolvableFormAction($key, $name, $param = NULL) {
 $this->m_propertyKey = $key;
 $this->m_name = $name;
 $this->m_param = $param;
 }

 function getName() {
 return $this->m_name;
 }
 
 function getParam() {
 return $this->m_param;
 }
 
 function perform( &$form, $jsParam ) {
 node_func( "resolveproperty" );
 $fC = &resolveProperty( $this->m_propertyKey , $form);
 $fC->resolveAction( $form, $this, $jsParam );
 }
}

class FormActionResolver extends BaseObject {
 function resolveAction(& $form, & $action, $jsParam) {
}
}

class FormChecker extends BaseObject {
 






 function check(& $form, $severity) {
}
}

class Button extends BaseObject {
 var $m_label;
 var $m_isEnabled = TRUE;
 var $m_isSubmit = TRUE;
 var $m_help;

 



 function Button($label, $isSubmit = TRUE, $isEnabled = TRUE) {
 $this->m_label = $label;
 $this->m_isSubmit = $isSubmit;
 $this->m_isEnabled = $isEnabled;
 }

 function setHelp( $help ) {
 $this->m_help = $help;
 }
 
 function getHelp() {
 return $this->m_help;
 }

 function doCheck()
 {
 return $this->m_isSubmit;
 }
 
 function setLabel($label) {
 $this->m_label = $label;
 }

 function getLabel() {
 return $this->m_label;
 }

 function setEnabled( $isEnabled )
 {
 $this->m_isEnabled = $isEnabled;
 }
 
 function isPressed($name) {
 
 global $$name;
 if ( isset( $$name ) )
 return TRUE;
 
 $name .= "_x";
 global $$name;
 if ( isset( $$name ) )
 return TRUE;
 return FALSE;
 }

 function _getHtml( $action, $name="", &$form=null ) {
 if ( $this->m_isEnabled ) {
 $templateName = "dialog.button";
 } else {
 $templateName = "dialog.button_disabled";
 }

 node_class("skeletonfactory");
 $skel = SkeletonFactory::getSkeleton();
 $help = $this->createHelpJsEvents( $form, $name, '' );
 return $skel->parseTemplate($templateName, array(
 "name" => $name,
 "text" => $this->m_label,
 "text_urlenc" => urlencode($this->m_label),
 "submit_func" => $action,
 "input_add" => $help ? $help["html"]." " : '')
 );
 }

 function getHtml(& $form, $name, $key) {
 global $BUTTONURL, $BUTTONDISABLEDURL;

 if ($this->m_isEnabled) {
 $onclick = $form->getJsButtonActionCall( $key );
 $templateName = "dialog.button";
 } else {
 $onclick = "";
 $templateName = "dialog.button_disabled";
 }
 return $this->_getHtml( $onclick, $name, $form );
 }

 












 function createHelpJsEvents( &$form, $key ) {
 $help = $this->getHelp();
 
 if ( !$help ) {
 return false;
 }

 $ret = $form->createHelpJs( $key, $this->getLabel(), '', $help );

 $ret["html"] = "onmouseover=\"".$ret["onmouseover"].";\" onfocus=\"".$ret["onfocus"].";\" onmouseout=\"".$ret["onmouseout"].";\"";
 return $ret;
 }
}



class HtmlForm3 extends BaseObject
{
 var $m_selfId = -1;

 var $m_component;
 var $m_componentId = -1;
 var $m_buttons = array();
 var $m_buttonActionKey = NULL;
 var $m_name;
 var $m_nestedForm = FALSE;
 var $m_jsChecks = array();
 var $m_customChecks = array();
 var $m_errors = array();
 var $m_firstErrorKey = "";
 var $m_isFinished = TRUE;
 var $m_isNew = TRUE;
 var $m_useErrorStyle = FALSE;
 var $m_header = "";
 var $m_icon = "";
 var $m_formtype = "";
 var $m_actionResolver = NULL;
 var $m_focusableElementName = "";
 var $m_template = "dialog";

 var $m_lastActionId = 1;
 var $m_restoredActions = array();
 var $m_actions = array();

 var $m_addHTML;

 var $m_helpKeys = array();
 var $m_assdelay = 800;

 function HtmlForm3($name, $tryRestoring = TRUE, $forceRestoring = FALSE) {
 global $ASSDELAY, $HTMLFORM3_SELFIDS;
 
 $this->m_name = $name;
 $this->m_component = new ListComponent();
 $main =& GUIFactory::getMainGUI();
 $main->includeJS( "htmlform" );
 $main->includeJS("jquery-1.6.1.min");
 $main->includeJS("jquery.tipsy");
 $this->m_header = "";
 $this->m_icon = "";
 $this->m_formtype = "normal";
 $this->m_addHTML = "";
 if ($ASSDELAY)
 $this->m_assdelay = $ASSDELAY;
 
 
 mysession_var_reg("HTMLFORM3_SELFIDS");
 if ( isset($HTMLFORM3_SELFIDS[$this->m_name]) ) {
 $this->m_selfId = $HTMLFORM3_SELFIDS[$this->m_name];

 if ( $tryRestoring )
 $this->restoreFromSession($forceRestoring); 
 else
 $this->clearSession();
 } else {
 $this->m_selfId = -1;
 }
 
 }
 
 function setNestedForm($form) {
 $this->m_nestedForm = $form;
 }
 
 function setHeader($header, $icon = "") {
 $this->m_header = $header;
 $this->m_icon = $icon;
 }

 function getHeader() {
 return $this->m_header;
 }
 
 function getIcon() {
 return $this->m_icon;
 }
 
 function setFormType($type) {
 $type = strtolower($type);
 if ($type && ($type != "normal" && $type != "search" && $type != "full"))
 return;
 if (!$type)
 $type = "normal";
 $this->m_formtype = $type;
 }

 function getFormType() {
 return $this->m_formtype;
 }

 function addHeader($html) {
 $this->m_addHTML .= $html;
 }

 function setTemplate($value) {
 $this->m_template = $value;
 }

 
 function getSerializeKey() {
 mysession_updateUnique( $this->m_componentId, $this->m_component );
 return array (
 "parent" => parent :: getSerializeKey(),
 "actions" => $this->m_actions,
 "header" => $this->m_header,
 "icon" => $this->m_icon,
 "ftype" => $this->m_formtype,
 "cid" => $this->m_componentId,
 "buttons" => node_serialize($this->m_buttons),
 "name" => $this->m_name,
 "customchecks" => $this->m_customChecks,
 "nested" => $this->m_nestedForm,
 "template" => $this->m_template
 );
 }

 function initFromSerializeKey( $var ) {
 parent::initFromSerializeKey( $var["parent"] );
 $this->m_restoredActions = $var["actions"];
 $this->m_header = $var["header"];
 $this->m_icon = $var["icon"];
 $this->m_formtype = $var["ftype"];
 $this->m_componentId = $var["cid"];
 $this->m_buttons = &node_unserialize( $var["buttons"] );
 $this->m_name = $var["name"];
 $this->m_customChecks = $var["customchecks"];
 $this->m_nestedForm = $var["nested"];
 $this->m_component = &mysession_loadUnique( $this->m_componentId, TRUE );
 $this->m_template = $var["template"];
 }

 function cleanupSerializeKey( $var ) {
 parent::cleanupSerializeKey( $var["parent"] );
 
 mysession_cleanupUnique($var["cid"]);
 }
 
 
 
 




 function & restoreComponent() {
 $componentVarPrefix = $this->m_name."_";

 if (!is_object($this->m_component)) {
 
 return false;
 }
 
 $fields = $this->m_component->getFields();
 reset($fields);
 while (list($key,$descr) = each($fields)) {
 $fn = $componentVarPrefix.$key;
 global $$fn;
 if (isset ($$fn)) {
 $this->m_component->setFieldValue( $key, $$fn );
 }
 }
 $this->m_component->onLoadFinished($this);
 return true;
 }

 function _getSeverity() {
 $severity = FM_SEVERITY_ALWAYS;
 
 if ( $this->m_useErrorStyle )
 $severity |= FM_SEVERITY_SUBMIT;
 return $severity; 
 }
 
 function _checkForErrors() {
 $this->m_firstErrorKey = "";
 $this->m_errors = array();
 $severity = $this->_getSeverity();
 foreach ($this->m_customChecks as $checker) {
 $checker->check( $this, $severity );
 }
 $e = $this->m_component->getError($severity);
 if ($e !== NULL) {
 if ( count($e) )
 $this->m_isFinished = FALSE;
 foreach ($e as $k => $v) {
 if (!$this->m_firstErrorKey) {
 $this->m_firstErrorKey = $k;
 }
 if (is_a($v, "nodeexception"))
 showMessage($v);
 $this->m_errors[$k] = $v;
 }
 }
 if ( $this->m_isFinished )
 $this->m_isFinished = $this->m_component->isFinished();
 }

 function & restoreButton($key) {
 $isPressed = FALSE;
 $bName = "btn".$this->m_name."$key";
 $btn = &$this->m_buttons[$key];
 if ($btn["button"]->isPressed($bName)) {
 $isPressed = TRUE;
 }
 return array (
 "pressed" => $isPressed,
 "button" => & $btn
 );
 }
 
 function restoreFromSession($forceRestoring) {
 $submit = "s".$this->m_name;
 $action = "a".$this->m_name;
 $actionParam = "p".$this->m_name;
 $bAction = "ba".$this->m_name;
 $bcAction = "bc".$this->m_name;
 $selfId = "se".$this->m_name;
 global $$submit;
 global $$action;
 global $$bAction;
 global $$bcAction;
 global $$selfId;
 global $$actionParam;
 if ( $this->m_selfId != $$selfId && isset($$selfId) ) {
 
 
 
 return;
 }
 
 
 if ($$submit == 1 || $forceRestoring == true) {
 $this->initFromSerializeKey( mysession_loadUnique( $this->m_selfId, TRUE ) );
 
 if (!$this->restoreComponent()) {
 
 $this->clearSession();
 return;
 };
 
 $this->m_isNew = FALSE;
 $this->m_isFinished = TRUE;

 
 $defaultPerformer = NULL;
 $performer = NULL;
 foreach ($this->m_buttons as $key => $button) {
 unset($rB);
 $rB = $this->restoreButton( $key );
 if ($rB["pressed"]) {
 $this->m_buttonActionKey = $key;
 $performer = &$this->m_buttons[$key]["action"];
 }
 if ($this->m_buttons[$key]["default"]) {
 $defaultPerformer = &$this->m_buttons[$key]["action"];
 }
 }
 if ($$action > 0) {
 $performer = &$this->m_restoredActions[$$action];
 $this->m_useErrorStyle = FALSE;
 } else
 if ($$bAction != "") {
 
 $performer = &$this->getButtonAction($$bAction);
 $this->m_useErrorStyle = ($$bcAction==1)?TRUE:FALSE;
 }
 $this->_checkForErrors();
 
 if ( $$action == 999999 ) 
 ;
 else
 if (is_object($performer)) {
 $this->_performAction ( $performer, $$actionParam );
 } else
 if (is_object($defaultPerformer)) {
 $this->_performAction ( $defaultPerformer, $$actionParam );
 }
 } else {
 $this->clearSession();
 }
 }

 function clearSession() {
 $key = mysession_loadUnique( $this->m_selfId, TRUE );
 $this->cleanupSerializeKey($key);
 }
 
 function _performAction(& $performer, $param) {
 if ($this->isError() && $this->m_useErrorStyle) {
 
 $this->m_buttonActionKey = NULL;
 return;
 }
 if ( is_object( $this->m_actionResolver ) && is_a( $performer, "resolvableformaction" ) )
 $this->m_actionResolver->resolveAction( $this, $performer, $param );
 else {
 $performer->perform( $this, $param );
 }
 }
 
 
 
 function getPropertyNames() {
 
 return $this->m_component->getComponents();
 }
 
 function & getProperty($key) {
 return $this->m_component->getComponent( $key );
 }
 
 function & getComponent($key) {
 return $this->m_component->getComponent( $key );
 }
 
 function & resolveComponent($key) {
 node_include("resolveproperty");
 return resolveProperty( $key, $this );
 }
 
 function getDefaultButtonName() {
 foreach ($this->m_buttons as $name => $button) {
 if ($button["default"])
 return $name;
 }
 return NULL;
 }
 
 function & getButton($name) {
 if ( $this->buttonExists($name) ){
 return $this->m_buttons[$name]["button"];
 }
 return NULL;
 }

 function & getButtonAction($name) {
 if ( $this->buttonExists($name) ) {
 return $this->m_buttons[$name]["action"];
 }
 return NULL;
 }
 
 function addComponent($key, & $formComponent) {
 $this->m_component->setComponent( $key, $formComponent );
 if ( $this->m_isFinished )
 $this->m_isFinished = $this->m_isFinished && $formComponent->isFinished();
 }
 
 function componentExists($key) {
 return $this->m_component->componentExists( $key );
 }
 
 function removeComponent($key) {
 $this->m_component->unsetComponent( $key );
 }
 
 function removeComponents() {
 $this->m_component->unsetComponents();
 }
 
 function addButton($name, & $button, & $action, $default = FALSE) {
 $this->m_buttons[$name] = array (
 "button" => & $button,
 "action" => & $action,
 "default" => $default
 );
 }
 
 function buttonExists($name) {
 return isset( $this->m_buttons[$name] );
 }
 
 function removeButton($name) {
 unset( $this->m_buttons[$name] );
 }
 
 function removeButtons() {
 $this->m_buttons = array();
 }
 
 function addJsCheck($expression) {
 $this->m_jsChecks[] = $expression;
 }

 function addCustomCheck(& $check) {
 $this->m_customChecks[] = &$check;
 }

 
 function getNoncheckingJsSubmitCall() {
 return "htmlform_action( '".$this->getFormName()."', '".$this->m_name."', '999999' );";
 }

 function getJsActionCall(& $action) {
 $this->m_actions[$this->m_lastActionId] = &$action;
 $id = $this->m_lastActionId;
 $this->m_lastActionId++;
 return "htmlform_action( '".$this->getFormName()."', '".$this->m_name."', '$id' );";
 }

 







 function getJsActionParamCall(& $action) {
 $call = $this->getJsActionCall($action);
 return substr( $call, 0, -2 );
 }

 
 function getJsButtonActionCall($bName) {
 if (!$bName)
 return "";
 $button =& $this->getButton($bName);
 $doCheck = $button->doCheck()?$this->getJsOnSubmitCall():"";
 $doCheck = addslashes($doCheck);
 return "htmlform_buttonAction( '".$this->getFormName()."', '".$this->m_name."', '$bName', '$doCheck' )";
 }

 function getJsOnSubmitCall() {
 return $this->m_name."_checkSubmit(  );";
 }
 
 function getName() {
 return $this->m_name;
 }
 
 function getFormName() {
 return ($this->m_nestedForm)?$this->m_nestedForm:$this->m_name;
 }
 
 function doCheck() {
 return TRUE;
 }
 
 function getClickedButtonKey() {
 return $this->m_buttonActionKey;
 }
 
 
 function isNew() {
 return $this->m_isNew;
 }
 
 function isFinished() {
 return $this->m_isFinished;
 }
 
 function isError() {
 return count($this->m_errors) > 0;
 }
 
 function getFirstError() {
 if ( is_array($this->m_errors[$this->m_firstErrorKey]) )
 $err = $this->m_errors[$this->m_firstErrorKey][0];
 else
 $err = $this->m_errors[$this->m_firstErrorKey];
 return $err->toString();
 }

 function clear() {
 $this->m_selfId = -1;
 
 unset ( $this->m_component );
 $this->m_component = new ListComponent();
 $this->m_componentId = -1;
 $this->m_buttons = array();
 $this->m_buttonActionKey = NULL;
 $this->m_jsChecks = array();
 $this->m_customChecks = array();
 $this->m_errors = array();
 $this->m_firstErrorKey = "";
 $this->m_isFinished = TRUE;
 $this->m_isNew = TRUE;
 $this->m_useErrorStyle = TRUE;
 $this->m_header = "";
 $this->m_icon = "";
 $this->m_formtype = "";
 $this->m_focusableElementName = "";
 
 $this->m_lastActionId = 1;
 $this->m_restoredActions = array();
 $this->m_actions = array();
 
 $this->m_addHTML = "";
 }
 
 
 function _getOnSubmitJs() {
 $fName = $this->m_name."_checkSubmit";
 $checks = "";
 foreach ($this->m_jsChecks as $check) {
 $errdiv = false;
 if(is_array( $check )) {
 $checkfunc = $check[0];
 $errdiv = $check[1];
 } else {
 $checkfunc = $check;
 }
 $checks .= "		{";
 $checks .= "if (tmp=($checkfunc)) { focusOnError = false; if ( !err ) err=tmp; }";
 if($errdiv) {
 $checks .= "var errdiv = document.getElementById('gtxform3_field_".$errdiv."');";
 $checks .= "if(tmp == 'false') tmp = false;";
 $checks .= "if(errdiv) { errdiv.innerHTML = tmp ? tmp : ''; errdiv.style.display = tmp ? 'block' : 'none'; }";
 }
 $checks .= "}\n";
 }
 
 
 






 $ret = "
	function $fName()
	{
		var aElement = getFormElement( '".$this->getFormName()."', 'a$this->m_name' );
		var baElement = getFormElement( '".$this->getFormName()."', 'ba$this->m_name' );
		var bcElement = getFormElement( '".$this->getFormName()."', 'bc$this->m_name' );
		if ( aElement.value > 0 ) {return true;}
		if ( baElement.value != '' && bcElement.value == '' ) {return true;}

		var ret = true;
		var tmp;
		var err = '';
		var focusOnError = true;
$checks
		//if ( err != '' ) alert ( err );
		return (err!='')?false:true;
	}
	";
 return $ret;
 }

 function _testForFocus($prefix) {
 if (!$this->m_focusableElementName) {
 $comp = &$this->m_component;
 if (!$this->isError()) {
 $fElementName = $comp->getFocusableElementName();
 if ( $fElementName !== NULL )
 $this->m_focusableElementName = $prefix . $fElementName;

 } else {
 reset( $this->m_errors );
 $this->m_focusableElementName = $this->m_name . "_" . key($this->m_errors);
 }
 }
 }

 function _getFormComponentHtml($prefix) {
 global $ICO_MINI, $STAG;

 $comp = &$this->m_component;
 
 $componentSIDName = "c".$this->m_name;

 
 if (is_object($comp)) {
 if ( $this->m_componentId < 0 )
 $this->m_componentId = mysession_createUnique();
 $comp->setUniqueKey( $this->m_componentId );
 if (!$this->m_isNew && $this->m_useErrorStyle) {
 $check = TRUE;
 } else
 $check = FALSE;

 if (!$comp->isHidden()) {
 $rs = $comp->getHTML( $this, $prefix, $check, $this->_getSeverity(), $key );
 if (!is_array($rs)) {
 if ($comp->getLabel() !== NULL) {
 $rs = array (
 array (
 $comp->getLabel(),
 $rs
 )
 );
 } else {
 $rs = array (
 $rs
 );
 }
 }

 $addCode = "<input type=hidden name=\"$componentSIDName\" value=\"$cSID\">\n";
 foreach($rs as $key=>$ele) {
 $out .= FormComponent::translateRow($ele, $addCode);
 $addCode = "";
 }

 } else {
 $out .= "<input type=hidden name=\"$componentSIDName\" value=\"$cSID\">\n";
 }
 }
 
 
 return $out;
 }
 
 function getHtmlOutput() {
 global $JS, $STAG, $DO;
 $this->_checkForErrors();

 $html = $this->_buildFormHeader();

 $html .= $this->_buildDialog( $this->_buildComponents(), $this->_buildButtons() );

 $html .= $this->_buildFormFooter();
 
 $html .= $this->_buildJS();

 return $html;
 }
 
 













 function createHelpJs($key, $label, $syntax, $help) {
 global $JS;

 
 static $helpIdSeq = 0;
 
 if ( !isset($this->m_helpKeys[$key]) ) {
 $this->m_helpKeys[$key] = ++$helpIdSeq;
 }
 $id = $this->m_helpKeys[$key];
 
 $JS .= "  cn_t[$id] = '".cleannl2br(htmlentities_utf8(strip_tags($label)))."';\n";
 $JS .= "  cn_s[$id] = '".cleannl2br(htmlentities_utf8($syntax))."';\n";
 $JS .= "  cn_h[$id] = '".cleannl2br(htmlentities_utf8($help))."';\n";

 $ret = array();
 $ret["onmouseover"] = "cn_show_hint($id, this)";
 $ret["onmouseout"] = "cn_hide_hint(this)";
 return $ret;
 }
 
 function _buildFormHeader() {
 global $JS, $STAG, $DO;

 if ( !$this->m_nestedForm ) {
 $html = "<form name=" . $this->m_name .
 " onsubmit=\"return ".$this->getJsOnSubmitCall()."\" ". 
 " method=POST ".
 " enctype=\"multipart/form-data\" ".
 " action=\"$STAG&do=$DO\">\n";
 
 $html .= '
<div id="hintbox">
	<h3 id="hintbox_title"></h3>
	<p id="hintbox_syntax"></p>
	<p id="hintbox_text"></p>
</div>';
 } else
 $html = "";
 
 $html .= "<input type=hidden name=s".$this->m_name." value=1>\n";
 
 $html .= "<input type=hidden name=a".$this->m_name." value=0>\n";
 
 $html .= "<input type=hidden name=ba".$this->m_name." value=\"\">\n";
 
 $html .= "<input type=hidden name=bc".$this->m_name." value=\"\">\n";
 
 $html .= "<input type=hidden name=p".$this->m_name." value=0>\n";

 $html .= $this->m_addHTML;
 return $html;
 }

 function _buildFormFooter() {

 global $HTMLFORM3_SELFIDS;
 
 
 if ($this->m_selfId < 0)
 $this->m_selfId = mysession_createUnique();
 $HTMLFORM3_SELFIDS[$this->m_name] = $this->m_selfId;
 
 mysession_updateUnique( $this->m_selfId, $this->getSerializeKey() );
 $html = "<input type=hidden name=se".$this->m_name." value=\"$this->m_selfId\">\n";
 if ( !$this->m_nestedForm )
 $html .= "</form>\n";
 
 return $html;
 }
 
 function _buildComponents() {
 
 $html = "<table border=0>\n";
 
 $prefix = $this->m_name."_";
 $html .= $this->_getFormComponentHtml( $prefix ). "\n";
 $html .= "</table>";
 $this->_testForFocus( $prefix );

 return $html;
 }

 function _buildButtons() {
 
 $html = "";
 foreach ($this->m_buttons as $key => $val) {
 $bName = "btn".$this->m_name."$key";
 $html .= $val["button"]->getHtml( $this, $bName, $key ) . "\n";
 }

 return $html;
 }

 function _buildDialog($content, $buttons) {
 
 global $FEATURE, $COLOR;
 
 
 if ($this->m_formtype == "search")
 $width = " width=\"100%\"";
 else
 if ($this->m_formtype == "full")
 $width = " width=\"100%\" height=\"100%\"";
 else
 $width = "";
 
 $headline = $this->m_header;
 $headicon = $this->m_icon;
 
 $html = "";

 if ($FEATURE["force_node2"]) {
 
 } else {

 node_class("skeletonfactory");
 $skel = SkeletonFactory::getSkeleton();
 $html = $skel->parseTemplate($this->m_template, array (
 "title" => $headline,
 "icon" => img($headicon),
 "width" => $width,
 "content" => $content,
 "buttons" => $buttons
 ));
 }
 return $html;
 }
 
 function _buildJS() {
 global $JS, $JS_ONLOAD;

 
 if ( $this->m_firstErrorKey ) 
 {
 
 }
 if ($this->m_focusableElementName) {
 $JS_ONLOAD .= "\n\tvar focusEle = getFormElement( '".$this->getFormName()."', '".
 $this->m_focusableElementName."' );\n";
 $JS_ONLOAD .= "\ttry{ focusEle.focus(); } catch (e) {}\n";

 }
 $JS .= $this->_getOnSubmitJs();
 return "";
 }

}

class HtmlForm3R extends HtmlForm3 {
 function HtmlForm3R($name, & $actionResolver, $tryRestoring = TRUE) {
 $this->m_actionResolver =&$actionResolver;
 parent::HtmlForm3($name, $tryRestoring);
 }
}
?>
