<?php

GUIFactory::setMainGUI("main");

mysession_var_reg("CNMAP_BROWSE_MAP");
mysession_var_reg("CNMAP_BROWSE_SEARCH");

mysession_var_reg("CNMAP_CMD");
mysession_var_reg("CNMAP_EDIT_ARG_ID");
mysession_var_reg("CNMAP_TAGMAPOPERATION");

mysession_var_reg("CNMAP_TYPE");
mysession_var_reg("CR_ID");

node_class("contentrepository");
node_class("htmlform3");
node_class("cncontentmap");



if($cmd) $CNMAP_CMD = $cmd;
if($type) $CNMAP_TYPE = $type;
if($tagmapoperation) $CNMAP_TAGMAPOPERATION = $tagmapoperation;
if($argid) {
 $CNMAP_EDIT_ARG_ID = $argid;
}

$ASSCORE = str_replace("\r","",str_replace("\n","<br>",i18n($CNMAP_TYPE == "tagmap" ? "tagmap editor general assistant" : "contentmap browser general assistant")));

function refreshNodeRelated() {
 global $CNMAP_BROWSE_SEARCH, $NODERELATED, $ICO_CONTENTMAP, $CNMAP_CMD, $DO, $STAG, $CNMAP_TYPE, $ICO_CONTENTMAP_TAGMAP;

 if( $CNMAP_TYPE == "tagmap" ) {
 $NODERELATED[$DO][0] = array( "icon" => $ICO_CONTENTMAP_TAGMAP,
 "link" => "$STAG&do=$DO&cmd=edit&argid=new",
 "text" => i18n( "New Tagmap Entry" ),
 "help" => i18n( "Create a new Tagmap Entry" ),
 "target" => "list"
 );
 } else {
 unset( $NODERELATED[$DO][0] );
 }
 if( $CNMAP_TYPE == "tagmap" && $CNMAP_CMD == "edit" ) {
 $NODERELATED[$DO][1] = array( "icon" => $ICO_CONTENTMAP_TAGMAP,
 "link" => "$STAG&do=$DO&type=tagmap&cmd=search",
 "text" => i18n( "Back to List" ),
 "help" => i18n( "Return to Tagmap List"),
 "target" => "list"
 );
 } else {
 unset( $NODERELATED[$DO][1] );
 }
}
refreshNodeRelated();

$contentmap = new CNContentmap();

$tagname = "";
$mapname = "";
$object = "";
$attributetype = "";
$multivalue = 0;
$optimized = 0;
$foreignlinkattribute = "";
$foreignlinkattributerule = "";
$objtype = "";
$static = 0;

if ($CNMAP_EDIT_ARG_ID && $CNMAP_EDIT_ARG_ID != "new") {
 $handle = $DB;
 $sql = "SELECT * FROM tagmap WHERE id = '".sqlslashes($CNMAP_EDIT_ARG_ID)."'";
 $rs = query( $sql, $handle );
 $v = $rs["arr"][0];
 $tagname = $v["tagname"];
 $mapname = $v["mapname"];
 $object = $v["object"];
 $attributetype = $v["attributetype"];
 $multivalue = $v["multivalue"];
 $optimized = $v["optimized"];
 $foreignlinkattribute = $v["foreignlinkattribute"];
 $foreignlinkattributerule = $v["foreignlinkattributerule"];
 $objtype = $v["objtype"];
 $static = $v["static"];
}

function connectToCR(&$form, $cr_id) {
 global $CNMAP_BROWSE_MAP;
 
 $sql = "SELECT username, password, dbtype, url FROM contentrepository WHERE id = " . sqlf_tl_num($cr_id);
 $res = query($sql);
 if (preg_match("/jdbc:mysql:\/\/([^\/]+)\/([^?]+).*/", $res["arr"][0]["url"], $matches)) {
 $server = $matches[1];
 $dbname = $matches[2];
 } else {
 
 }
 
 
 
 $CNMAP_BROWSE_MAP = mydb_connect(
 $dbname,
 $server,
 $res["arr"][0]["username"],
 $res["arr"][0]["password"],
 $res["arr"][0]["dbtype"],
 true, false, true, "utf8");
 
 if (!$CNMAP_BROWSE_MAP) {
 $fMap = &$form->resolveComponent( "map" );
 $fMap->setFieldError("map", new NodeException(i18n("cr_connect_fail"), ""));
 }
}





function changeCR(&$form, $param) {

 
 $fMap = &$form->resolveComponent( "map" );
 $cr_id = $fMap->getSingleSelection();

 if ($cr_id) {
 doChangeCR($form, $cr_id);
 }
}




function doChangeCR(&$form, $cr_id) {
 connectToCR($form, $cr_id);
 
 $cr = new ContentRepository($cr_id);
 $isMCCR = $cr->isMultichannelingCR();
 
 global $CNMAP_BROWSE_MAP, $CNMAP_BROWSE_SEARCH;
 $fChannel = &$form->resolveComponent( "channel" );
 if ($isMCCR && isset($CNMAP_BROWSE_MAP)) {
 populateTheChannelSelection($fChannel);
 $fChannel->setVisible(true);
 } else {
 
 
 unset($CNMAP_BROWSE_SEARCH['channel']);
 $fChannel->setVisible(false);
 $fChannel->setOptions(array());
 }
}






function populateTheChannelSelection(& $fChannel) {
 global $CNMAP_BROWSE_MAP;
 
 $sql = "SELECT id, name from channel where id > 0";
 $rs = query($sql, $CNMAP_BROWSE_MAP);
 $channelSelection = array();
 $sel = null;
 foreach ($rs['arr'] as $row) {
 $channelSelection[$row['id']] = "[" . $row['id'] . "] " . $row['name'];
 if ($sel == null) {
 $sel = $row['id'];
 }
 }
 $fChannel->setOptions($channelSelection);
 $fChannel->setSelection(array($sel));
}






function changeChannel(&$form, $param) {
 global $CNMAP_BROWSE_SEARCH;
 $fChannel = &$form->resolveComponent( "channel" );
 $CNMAP_BROWSE_SEARCH["channel"] = $fChannel->getSingleSelection();
 startSearch($form, $param);
}

function changeIdType( &$form, $param ) {

 $id =& $form->resolveComponent( "id" );
 $type =& $form->resolveComponent( "type" );
 
 $label = $type->getSingleSelection() == "custom" ? i18n("Type.ID") : i18n("ID");
 $id->setHelp( i18n( ($type->getSingleSelection() == "custom" ?
 "Enter the Type and ID of the object you want to display. E.g. 10007.58385" :
 "Enter the ID of the object you want to display. E.g. 58385" ) ) );
 
 $id->setLabel( $label );
}

function startSearch( &$form, $param ) {

 global $CNMAP_BROWSE_MAP, $CNMAP_BROWSE_SEARCH, $CR_ID;
 
 $map =& $form->resolveComponent( "map" );
 $type =& $form->resolveComponent( "type" );
 $id =& $form->resolveComponent( "id" );
 $table =& $form->resolveComponent( "table" );
 $binary =& $form->resolveComponent( "binary" );
 $channel =& $form->resolveComponent( "channel" );
 
 $CR_ID = $map->getSingleSelection();

 if (!isset($CNMAP_BROWSE_MAP)) {
 connectToCR($form, $CR_ID);
 }

 $CNMAP_BROWSE_SEARCH = array();
 $CNMAP_BROWSE_SEARCH["type"] = $type->getSingleSelection();
 $CNMAP_BROWSE_SEARCH["id"] = $id->getText();
 $CNMAP_BROWSE_SEARCH["table"] = $table->getSingleSelection();
 $CNMAP_BROWSE_SEARCH["binary"] = $binary->isChecked();
 
 if ($channel->isHidden()) {
 unset($CNMAP_BROWSE_SEARCH["channel"]);
 } else {
 $CNMAP_BROWSE_SEARCH["channel"] = $channel->getSingleSelection();
 }
 
 refreshNodeRelated();
}

function changedAttributetype( &$form, $param ) {
 $fattributetype =& $form->resolveComponent( "attributetype" );
 $fforeignlinkattribute =& $form->resolveComponent( "foreignlinkattribute" );
 $fforeignlinkattribute->setVisible( $fattributetype->getSingleSelection() == 7 );
 $fforeignlinkattributerule =& $form->resolveComponent( "foreignlinkattributerule" );
 $fforeignlinkattributerule->setVisible( $fattributetype->getSingleSelection() == 7 );
 $fobjtype =& $form->resolveComponent( "objtype" );
 $fobjtype->setVisible( $fattributetype->getSingleSelection() == 2 || $fattributetype->getSingleSelection() == 7 );
}


if (!$CNMAP_BROWSE_MAP["handle"] && is_array($CNMAP_BROWSE_MAP)) {
 $CNMAP_BROWSE_MAP = mydb_connect(
 $CNMAP_BROWSE_MAP["db"],
 $CNMAP_BROWSE_MAP["server"],
 $CNMAP_BROWSE_MAP["login"],
 $CNMAP_BROWSE_MAP["pw"],
 $CNMAP_BROWSE_MAP["type"],
 true, true, true,
 $CNMAP_BROWSE_MAP["charset"]
 );
}
$form = new HtmlForm3( "cnmap_search" );

$STATUS = "";

 $where = "";
if ( $CNMAP_TYPE == "tagmap" && $CNMAP_TAGMAPOPERATION == "verify" ) {
 

 
 
 
 $sql = "SELECT c1.id AS c1id,c1.tagname AS c1tagname,c1.mapname AS c1mapname,c1.object AS c1object, c2.id AS c2id,c2.object AS c2object,c2.tagname AS c2tagname FROM tagmap AS c1 LEFT JOIN tagmap AS c2 ON c1.mapname = c2.mapname AND (c1.optimized != c2.optimized OR c1.attributetype != c2.attributetype OR c1.multivalue != c2.multivalue) WHERE c2.id IS NOT NULL OR (c1.optimized = 1 AND c1.multivalue = 1)";
 $rs = query( $sql );
 if( count($rs["arr"]) > 0 ) {
 $conflicts = "";
 while( list( $key, $row ) = each($rs["arr"]) ) {
 
 if( $where != "" ) $where .= ",";
 $where .= sqlf_tl_num($row["c1id"]);
 if( $row["c2id"] ) {
 $conflicts .= i18n( "Mapname: '{0}' - Tagname '{1}' (Object Type: {2}) conflicts with Tagname '{3}' (Object Type: {4})",0, $row["c1mapname"],$row["c1tagname"],$row["c1object"],$row["c2tagname"],$row["c1object"] );
 $conflicts .= "<br/>";
 } else {
 $conflicts .= i18n( "Tagname '{0}' is marked as optimized and multivalue at the same time.", 0, $row["c1tagname"] ) . "<br/>";
 }
 }
 $where = "id IN ( $where )";
 $STATUS = "<br/><span style='color:red'>".i18n( "Tagmap Integrity test failed. {0} Tagmap conflicts found:", 0, count( $rs["arr"] ) )."</span><br/>$conflicts<br/><a href='$STAG&do=$DO&tagmapoperation=none'>" . i18n( "Disable Integrity Check" ) . "</a><br/><br/>";
 } else {
 
 $STATUS = "<br/><span style='color:green'>".i18n( "Tagmap Integrity successfully verified." )."</span><br/><br/>";
 $CNMAP_TAGMAPOPERATION = "";
 }
}

if ( $form->isNew() ) {
 node_include("ICONS");
 node_class("selectcomponent");
 node_class("textcomponent");
 node_class("checkboxcomponent");
 node_class("labelcomponent");
 node_class("contentrepository");
 
 if( $CNMAP_CMD != "edit" || $CNMAP_TYPE != "tagmap" ) {
 $options = ContentRepository::getSelectOptions("WHERE dbtype = 'mysql'");
 if (!$CR_ID && count($options) > 0) {
 $CR_ID = each($options);
 $CR_ID = $CR_ID[0];
 reset($options);
 }
 $fMap = new SelectComponent( "ContentRepository (MySQL)", $options, $CR_ID, false );
 $fMap->setOnChangeAction ( new SimpleFormAction( "changeCR" ) );
 $fMap->setAllowEmpty( false );
 $fMap->setHelp( i18n( "Choose the Contentmap to load data from." ) );
 
 $types = array( "custom" => ($type == "tagmap" ? "All" : "Custom" ), 10002 => "Folder (10002)", 10007 => "Page (10007)", 10008 => "File (10008)" );
 $fType = new SelectComponent( i18n( "Type" ), $types, $CNMAP_BROWSE_SEARCH["type"], false );
 $fType->setOnChangeAction ( new SimpleFormAction( "changeIdType" ) );
 $fType->setAllowEmpty( false );
 $fType->setHelp( i18n( "Choose the type of the object(s) you want to display" ) );
 
 if( $CNMAP_TYPE == "tagmap" ) {
 $tables = array( "tagmap" => i18n( "Tagmap" ) );
 } else {
 $tables = array( "contentmap"=>i18n("Contentmap"), "contentattribute"=>i18n("contentattribute") );
 }
 if( $FEATURE["cnmap_updatenotification"] ) {
 $tables["notification"] = i18n("Notification");
 }
 $fTable = new SelectComponent( i18n( "Table" ), $tables, ($CNMAP_TYPE == "tagmap" ? "tagmap" : $CNMAP_BROWSE_SEARCH["table"]), false );
 $fTable->setAllowEmpty( false );
 $fTable->setVisible( $CNMAP_TYPE != "tagmap" );
 $fTable->setHelp( i18n( "Choose the table from which to display the Results. (Contentmap = List of all Objects, Contentattribute = All attributes of those objects.)" ) );
 
 $fChannel = new SelectComponent( i18n("Channel"), array(), true, false);
 $fChannel->setAllowEmpty(false);
 $fChannel->setVisible(false);
 $fChannel->setHelp( i18n( "cr_browser_channel_help" ) );
 $fChannel->setOnChangeAction ( new SimpleFormAction( "changeChannel" ) );

 $fId = new TextComponent( (!$CNMAP_BROWSE_SEARCH["type"] || $CNMAP_BROWSE_SEARCH["type"] == "custom" ?
 i18n("Type.ID") : i18n( "ID" ) ), true, $CNMAP_BROWSE_SEARCH["id"] );
 $fId->setVisible( $CNMAP_TYPE != "tagmap" );
 $fId->setHelp( i18n( (!$CNMAP_BROWSE_SEARCH["type"] || $CNMAP_BROWSE_SEARCH["type"] == "custom" ?
 "Enter the Type and ID of the object you want to display. E.g. 10007.58385" :
 "Enter the ID of the object you want to display. E.g. 58385" ) ) );
 
 $fBinary = new Checkboxcomponent( i18n("Show binary Data"), $CNMAP_BROWSE_SEARCH["binary"] );
 $fBinary->setVisible( $CNMAP_TYPE != "tagmap" );
 $fBinary->setHelp( i18n( "Activate this option if large contents should be displayed (e.g. Page Contents or Binary Contents of Files)" ) );


 $form->setHeader( i18n( $CNMAP_TYPE == "tagmap" ? "Tagmap Editor" : "Contentmap Browser" ), $CNMAP_TYPE == "tagmap" ? $ICO_CONTENTMAP_TAGMAP : $ICO_CONTENTMAP );
 $form->addComponent( "map", $fMap );
 $form->addComponent( "table", $fTable );
 $form->addComponent( "channel", $fChannel );
 $form->addComponent( "type", $fType );
 $form->addComponent( "id", $fId );
 $form->addComponent( "binary", $fBinary );
 
 $form->addButton( "search", new Button( i18n ( "Load" ) ), new SimpleFormAction( "startSearch" ), true );
 
 if ($CR_ID) {
 doChangeCR($form, $CR_ID);
 }
 } else {

 $form->setHeader( i18n( "Edit Tagmap Entry" ),$ICO_CONTENTMAP_TAGMAP  );

 $form->addComponent( "mapname", $fmapname = new TextComponent( i18n( "mapname" ), true, $mapname, REG_TEXT_SHORT ) );
 $fmapname->setEditable( ! $static );
 $fmapname->setDisabled( $static );
 $fmapname->setHelp( i18n( "Enter the attribute name for this entry under which it will be known in the Gentics Content Repository." ) );
 $form->addComponent( "tagname", $ftagname = new TextComponent( i18n( "tagname" ), true, $tagname ) );
 $ftagname->setEditable( ! $static );
 $ftagname->setDisabled( $static );
 $ftagname->setHelp( i18n( "Enter the tagmap name for this entry. (The Tag name in Gentics Content.Node e.g. object.myobjprop)" ) );

 $objTypes = array( "10002" => "[10002] Folder",
 "10007" => "[10007] Page",
 "10008" => "[10008] File" );
 $form->addComponent( "object", $fobject = new SelectComponent( i18n( "object" ) ,
 $objTypes, $object ) );
 $fobject->setEditable( ! $static );
 $fobject->setHelp( i18n( "Enter the Object Type this Tagmap entry applies to." ) );

 $form->addComponent( "attributetype", $fattributetype = new SelectComponent( i18n( "attributetype" ),
 array( "1" => "[1] Text (short)",
 "2" => "[2] Object Link",
 "3" => "[3] Integer",
 "5" => "[5] Text (long)",
 "6" => "[6] Binary",
 "7" => "[7] Foreign Link"), $attributetype ) );
 $fattributetype->setHelp( i18n( "Choose the Type for the attribute in the Gentics Content Repository." ) );
 $fattributetype->setOnChangeAction ( new SimpleFormAction( "changedAttributetype" ) );
 $fattributetype->setEditable( ! $static );

 $form->addComponent( "multivalue", $fmultivalue = new CheckboxComponent( i18n("Multivalue"), $multivalue ) );
 $fmultivalue->setEditable( ! $static );
 $fmultivalue->setHelp( i18n( "Choose if this attribute can contain multiple values." ) );

 $form->addComponent( "optimized", $foptimized = new CheckboxComponent( i18n("Optimized"), $optimized ) );
 $foptimized->setEditable( true );
 
 $foptimized->setHelp( i18n( "Activate optimized if many operations depend on this Attribute - But be careful, activating this option will increase the size of the database and may even slow down overall performance if not used carefully (It should also be noted that the next publish run might run significantly longer than usual)." ) );

 $form->addComponent( "objtype", $fobjtype = new SelectComponent( i18n( "Linked Object Type" ), $objTypes, $objtype ) );
 $fobjtype->setEditable( ! $static );
 $fobjtype->setHelp( i18n( "Choose the linked object type." ) );

 $form->addComponent( "foreignlinkattribute", $fforeignlinkattribute = new TextComponent( i18n( "Foreignlink Attribute" ), true, $foreignlinkattribute ) );

 $fobjtype->setVisible( $attributetype == 2 || $attributetype == 7 );
 $fforeignlinkattribute->setHelp( i18n( "Enter the name of the Link Attribute of the Linked Object Type which references to this Object Type." ) );
 $fforeignlinkattribute->setVisible( $attributetype == 7 );
 $fforeignlinkattribute->setEditable( ! $static );

 $form->addComponent( "foreignlinkattributerule", $fforeignlinkattributerule = new TextAreaComponent( i18n("Foreignlink Attribute Rule"), true, $foreignlinkattributerule ) );
 $fforeignlinkattributerule->setHelp( i18n( "foreignlinkattributerule_help" ));
 $fforeignlinkattributerule->setVisible( $attributetype == 7 );
 $fforeignlinkattributerule->setEditable( ! $static );

 $form->addComponent( "status", $ftextcomponent = new LabelComponent( i18n( "Status" ), "", true ) );
 $ftextcomponent->setVisible( false );

 $form->addButton( "save", new Button( i18n( "Save" ) ), new SimpleFormAction( "saveTagmapEntry" ), true );
 $form->addButton( "cancel", new Button( i18n( "Cancel" ), false ), new SimpleFormAction( "cancelTagmapEntry" ), true );
 
 }
}

if ($cbType) {
 $CNMAP_BROWSE_SEARCH["table"] = $cbType;
 if( $cmd != "edit" ) {
 $cfTable =& $form->resolveComponent("table");
 $cfTable->setSelection( $cbType );
 }
}
if ($cbID) {
 $parts = explode(".", $cbID);
 if (count($parts) != 2 || ($parts[0] != 10002 && $parts[0] != 10007 && $parts[0] != 10008)) {
 $CNMAP_BROWSE_SEARCH["type"] = "custom";
 $CNMAP_BROWSE_SEARCH["id"] = $cbID;
 } else {
 $CNMAP_BROWSE_SEARCH["type"] = (int) $parts[0];
 $CNMAP_BROWSE_SEARCH["id"] = $parts[1];
 }
 $cfType =& $form->resolveComponent("type");
 $cfId =& $form->resolveComponent("id");

 $cfType->setSelection(array($CNMAP_BROWSE_SEARCH["type"]));
 $cfId->setText($CNMAP_BROWSE_SEARCH["id"]);
}
if ($CNMAP_BROWSE_MAP || $CNMAP_TYPE == "tagmap") {

 node_class("itemlist3");
 node_class("sqldatasource");
 node_class("resultsetformatter");
 node_class("dateformatter");

 class AttributeTypeFormatter extends ResultsetFormatter {
 
 var $column;
 
 function AttributeTypeFormatter( $col ) {
 $this->column = $col;
 }

 function format( $row, $params = "" ) {
 $type = $row[$this->column];
 $out = "[$type] ";
 switch ($type) {
 
 case 0: $out .= "Unknown"; break;
 case 1: $out .= "Text (short)"; break;
 case 2: $out .= "Object"; break;
 case 3: $out .= "Integer"; break;
 case 4: $out .= "Binary"; break;
 case 5: $out .= "Text (long)"; break;
 case 6: $out .= "BLOB"; break;
 case 7: $out .= "Foreign Link"; break;
 default: $out .= " Undefined";
 }
 return $out;
 }
 }

 class ObjectTypeFormatter extends ResultsetFormatter {
 var $column;

 function ObjectTypeFormatter( $col ) {
 $this->column = $col;
 }
 function format( $row, $params = "" ) {
 $type = $row[$this->column];
 $out = "[$type] ";
 switch( $type ) {
 case 0: $out = "N/A"; break;
 case 10002: $out .= "Folder"; break;
 case 10007: $out .= "Page"; break;
 case 10008: $out .= "File"; break;
 default: $out .= "Unknown"; break;
 }
 return $out;
 }
 }
 class BooleanFormatter extends ResultsetFormatter {
 var $column;

 function BooleanFormatter( $col ) {
 $this->column = $col;
 }
 function format( $row, $params = "" ) {
 $bool = $row[$this->column];
 if( $bool ) return "Yes";
 return "No";
 }
 }

 class ReservedFormatter extends ResultsetFormatter {
 var $column;
 function ReservedFormatter( $col ) {
 $this->column = $col;
 }

 function format( &$row, $params = "" ) {
 $row["changeable"] = !$row["static"];
 return $row["changeable"] ? '' : i18n( "Reserved" );
 }
 }
 
 class CnBrowseAttributeFormatter extends ResultsetFormatter {

 var $link;
 var $types;
 var $param;
 var $column;

 function CnBrowseAttributeFormatter($types, $link, $param, $column) {
 $this->link = $link;
 $this->types = $types;
 $this->param = $param;
 $this->column = $column;
 }

 function getContentType($row) {
 $cid = explode(".", $row["contentid"]);
 return $cid[0];
 }
 }
 
 class CnBrowseTextFormatter extends CnBrowseAttributeFormatter {
 
 function format ($row, $params = "") {
 global $STAG;
 
 $val = $row[$this->column];
 $name = $row["name"]; 
 $type = $this->getContentType($row);
 
 if ($val && $this->types[$type][$name]["attributetype"] == ATTR_TYPE_OBJ) {
 $param = "&".$this->param."=".$row[$this->column];
 $val = "<a href=\"javascript:".ProgressStatusInfo::buildProgressLink( $STAG."&".$this->link.$param, "list" ).
 "\" target=\"list\">".$val."</a>";
 }
 
 return $val;
 }
 }
 
 class CnBrowseIntFormatter extends CnBrowseAttributeFormatter {

 function format ($row, $params = "") {
 $val = $row[$this->column];
 $name = $row["name"];

 if (strpos($name, "timestamp") !== false) {
 $val = date("d.m.Y H:i:s", $val);
 }

 return $val;
 }
 }
 
 class CnBrowseBinaryFormatter extends CnBrowseAttributeFormatter {
 
 var $showBinary;
 
 function CnBrowseBinaryFormatter($types, $link, $param, $column, $showBinary = false) {
 parent::CnBrowseAttributeFormatter($types, $link, $param, $column);
 $this->showBinary = $showBinary;
 }
 
 function format ($row, $params = "") {
 $val = $row[$this->column];

 if ($val) {

 if (!$this->showBinary) {
 
 $size = strlen($val);
 if ($size > 1024) $size = (round(10*$size/1024)/10)."kb";
 else $size .= "b";
 
 $val = "[data; $size]";
 } else {
 $val = str_replace("\n","<br />\n", htmlspecialchars($val));
 }
 }
 
 return $val;
 }
 }

 $handle &= $contentmap->getCnMapHandleByKey( $CNMAP_BROWSE_MAP );
 
 if ($CNMAP_BROWSE_SEARCH["table"] == "contentmap" || $CNMAP_BROWSE_SEARCH["table"] == "contentattribute") {
 $sql = "SELECT * FROM tagmap";
 $tagmap = query($sql, $DB );

 $quick_cols = array();
 $types = array();
 foreach ($tagmap["arr"] as $key=>$row) {
 $types[$row["object"]][$row["mapname"]] = $row;
 
 if ($row["optimized"]) $quick_cols[$row["mapname"]] = $row;
 }
 }
 
 $table = $CNMAP_BROWSE_SEARCH["table"];
 if ($table == "notification") $table = $contentmap->getCnMapNotificationTableByKey( $CNMAP_BROWSE_MAP );
 if( $CNMAP_TYPE == "tagmap" ) {
 $handle = $DB;
 $table = "tagmap";
 } else if( $table == "tagmap" ) {
 $table = "";
 }
 if ($table) {
 
 
 $struct = mydb_desc_table( $table, $CNMAP_BROWSE_MAP );

 
 ksort($struct);

 $cid = ($CNMAP_BROWSE_SEARCH["type"] != "custom") ? $CNMAP_BROWSE_SEARCH["type"]."." : "";
 $cid .= ($CNMAP_BROWSE_SEARCH["table"] == "tagmap" ||
 $CNMAP_BROWSE_SEARCH["table"] == "contentmap" && $CNMAP_BROWSE_SEARCH["id"] == "" ? "%" : $CNMAP_BROWSE_SEARCH["id"] );
 $cid = sqlslashes( $cid, $handle );

 if ($struct["contentid"]) {
 $mccrFilter ="";
 if (isset($CNMAP_BROWSE_SEARCH['channel'])) {
 $mccrFilter = " and channel_id = " . sqlf_escaped($CNMAP_BROWSE_SEARCH['channel']);
 }
 $where = "contentid ".(strpos( $cid, "%" ) === false?"=":"LIKE")."\"".sqlf_escaped($cid)."\"". $mccrFilter;
 } else {
 
 if (isset($CNMAP_BROWSE_SEARCH['channel']) && $cid) {
 $sql = "SELECT id from contentmap where contentid = ". sqlf_escaped($cid) . " and channel_id = " . sqlf_escaped($CNMAP_BROWSE_SEARCH['channel']);
 $rs = query($sql, $CNMAP_BROWSE_MAP);
 $resultId = $rs['arr']['0']['id'];
 $contentMapID = -1;
 if (isset($resultId)) {
 $contentMapID = $resultId;
 }
 $where = "map_id = " . sqlf_escaped($contentMapID);
 }
 }
 node_class( "commandaction" );
 $ds = new SQLDatasource( sqlf_table($table), "*", sqlf_table($table), $where );
 $ds->setDBHandle($CNMAP_BROWSE_MAP);
 if ($FEATURE['tagmap_notsearchable']) {
 $ds->setSearchable( false );
 } else {
 $ds->setSearchable( true );
 }
 
 switch ($table) {
 case "tagmap":

 $ds->addColumn( "reserved", i18n( "reserved" ), false, false, "static" );
 $ds->addFormatter( "reserved", new ReservedFormatter( "reserved" ) );
 

 $ds->addColumn( "mapname", i18n( "mapname" ), true, true, true );
 foreach ($struct as $field=>$desc) {
 if ($field == "attributetype") {
 $ds->addColumn( "lnkattributetype", i18n($field), false, false, $field );
 $ds->addFormatter( "lnkattributetype", new AttributeTypeFormatter( "attributetype" ) );
 } else if ($field == "searchname" || $field == "id" ) {
 
 } else if( $field == "static" ) {
 
 } else if( $field == "mapname" ) {
 
 } else if( $field == "object" || $field == "objtype" ) {
 $ds->addColumn( "new".$field, i18n( $field ), false, false, $field );
 $ds->addFormatter( "new".$field, new ObjectTypeFormatter( $field ) );
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 if( $field == "multivalue" || $field == "optimized" ) {
 $ds->addFormatter( $field, new BooleanFormatter( $field ) );
 }
 }
 $ds->addSearchableColumn( "mapname" );
 $ds->makeLink( "mapname", "mapname", "do=$DO&cmd=edit&cbType=tagmap", "list", 
 array( "argid" ), 
 array( "id" ));
 $ds->addSearchableColumn( "tagname" );
 

 $ds->addAction( new CommandAction( $ICO_DELETE, "del", i18n( "Delete" ), "deleteTagmapEntry" ) );

 break;
 case "contentmap":
 foreach ($struct as $field=>$desc) {
 
 if ($field == "contentid") {
 $ds->addColumn( "lnkcontentid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkcontentid", $field, "do=$DO&cbType=contentattribute", "list", "cbID", "contentid" );
 
 } else if ($field == "motherid") {
 $ds->addColumn( "lnkmotherid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkmotherid", $field, "do=$DO&cbType=contentmap", "list", "cbID", "motherid", "motherid" );
 
 } else if ($field == "updatetimestamp") {
 $ds->addColumn( "dt$field", i18n($field), false, false, $field );
 $ds->addFormatter( "dt$field", new DateFormatter( $field, "d.m.Y H:i:s" ) );
 
 } else if (substr($field, 0, 6) == "quick_" && $quick_cols[$field]["attributetype"] == ATTR_TYPE_OBJ) {
 $ds->addColumn( "lnk$field", i18n($field), false, false, $field );
 $ds->makeLink( "lnk$field", $field, "do=$DO&cbType=contentmap", "list", "cbID", $field, $field );
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 }
 break;
 case "contentattribute":
 foreach ($struct as $field=>$desc) {
 
 if ($field == "contentid") {
 $ds->addColumn( "lnkcontentid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkcontentid", $field, "do=$DO&cbType=contentmap", "list", "cbID", "contentid" );

 } else if ($field == "updatetimestamp") {
 $ds->addColumn( "dt$field", i18n($field), false, false, $field );
 $ds->addFormatter( "dt$field", new DateFormatter( $field, "d.m.Y H:i:s" ) );

 } else if ($field == "value_text") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseTextFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field ) );
 
 } else if ($field == "value_int") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseIntFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field ) );
 
 } else if ($field == "value_bin" || $field == "value_blob" || $field == "value_clob") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseBinaryFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field, $CNMAP_BROWSE_SEARCH["binary"] ) );
 
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 }
 $ds->addSearchableColumn( "name" );
 $ds->addSearchableColumn( "value_text" );
 break;
 case "notification":
 foreach ($struct as $field=>$desc) {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 break;
 default:
 assert(0); 
 }
 
 if (is_object($ds)) {
 $ds->setDBHandle( $CNMAP_BROWSE_MAP );
 
 
 $list = new ItemList3( "cnmap_browse", $ds );
 $list->setShowInfo( true );
 $list->setMaxListItems(30);
 }
 }}

load_menu(15201, ($CNMAP_TYPE == "tagmap" ? $T_TAGMAP_EDITOR : $T_CONTENTMAP_BROWSER ), 0, "", 0, array( $CNMAP_TYPE ) );
 
?>