<?php






class CNDirt extends NodeObject {

 var $o_id;
 var $o_type;
 
 



 function CNDirt( $TType, $id = 0 ) {
 parent::NodeObject( $TType );
 $this->setObjectId($id);
 }
 
 function setObjectId($id) {
 $this->o_id = $id;
 }
 
 function setObjectType($type) {
 $this->o_type = $type;
 }

 function getObjectType() {
 return $this->o_type;
 }

 function _setID($id) {
 $this->setObjectType($id);
 }

 function getID() {
 return $this->getObjectType();
 }
 
 


 function onStaticEventNotify( $TType, $id, $changeType, $eventObject, $depth, $simulate ) {
 global $FEATURE, $T_PAGE, $T_TEMPLATE, $W_MODIFY, $USER_ID;
 
 
 if ($FEATURE["dirt3"]) return;
 if ($simulate && $simulate > 0) return;

 if (($changeType & EVENT_CN_OBJPROP) && ($TType == $T_PAGE || $TType == $T_TEMPLATE)) {
 if( $TType == $T_PAGE ) {
 $pageinfo = get_pageinfo( $id, 'page.status' );
 if( $pageinfo['status'] != 3 ) { 
 page_status( $id, 0, $USER_ID );
 }
 }
 return;
 }
 $dirt = new CNDirt( $TType, $id );
 if ($dirt->isDirtEvent( $changeType, $depth )) {
 $dirt->dirtObject($changeType, $depth);
 }
 
 }

 function isDirtEvent( $changeType, $depth = 0 ) {
 
 if ( $changeType & EVENT_PARENT ) return false;
 return true;
 }
 
 function dirtObject( $eventType = EVENT_ALL, $depth = 0) {
 global $FEATURE, $DEBUG;
 
 
 if (($eventType & EVENT_CHILD) && ($eventType != EVENT_ALL)) return;
 
 if ($FEATURE["dirt2"]) {
 if ($this->o_id) $this->_dirtObject2($this->o_type, $this->o_id, $eventType);
 } else {
 if ($this->o_id) $this->_dirtObject1($this->o_type, $this->o_id, $eventType);
 }
 }
 
 function clearCache() {
 objtranslatecache_clear($this->o_id, $this->o_type);
 }

 




 function dirtAll() {
 global $FEATURE;
 if ($FEATURE["no_dirtall"]) return;
 dirt_linked_of_all();
 }
 
 

 
 function getObjectOfTag($tag) {
 $object = NULL;
 $tmp = $tag->get_object_of_tag();
 if ($tmp && is_object($tmp)) {
 if (!$tmp->id) 
 warning(101,"get_objects_of_tagslist creates invalid object: ".$tag["contenttag_id"].",".$tag["templatetag_id"].",".$tag["objtag_id"]);
 else $object = $tmp;
 }
 return $object;
 }
 
 
 function _dirtObject2($type, $id, $event) {
 
 switch ($type) {
 case T_PART:
 $sql = "SELECT construct_id FROM part WHERE id = ".sqlf_tl_num((int)$id);
 $rs = query($sql);
 if (!($id = $rs["arr"][0]["construct_id"])) break;
 case T_CONSTRUCT:
 $my = new construct_object($id);
 break;
 case T_FOLDER:
 $my = new folder_object($id);
 break;
 case T_PAGE:
 $my = new page_object($id);
 break;
 case T_PAGECONTENT:
 $my = new content_object($id);
 break;
 case T_TEMPLATE:
 $my = new template_object($id);
 break;
 case CT_FILE:
 case T_IMAGE:
 $my = new file_object($id);
 break;
 case T_CONTENTTAG:
 $tag = new contenttag_object($id);
 $my = CNDirt::getObjectOfTag($tag);
 break;
 case T_TEMPLATETAG:
 $tag = new templatetag_object($id);
 $my = CNDirt::getObjectOfTag($tag);
 break;
 case T_OBJTAG:
 $tag = new objtag_object($id);
 $my = CNDirt::getObjectOfTag($tag);
 break;
 case T_NODE:
 $my = new nodefolder_object($id);
 break;
 default:
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "type to dirt unknown ($type, $id, $event)<br>";
 return;
 }
 
 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_folder()<br>', 'nodirt');
 return;
 }
 
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "DirtObject($type, $id, $event)<br>";
 
 if (is_object($my)) {
 $my->start_dirtcount();
 $my->dirt_all($event);
 }
 }
 
 
 function _dirtObject1($type, $id, $event) {
 
 switch ($type) {
 case T_PART:
 $sql = "SELECT construct_id FROM part WHERE id = ".sqlf_tl_num((int)$id);
 $rs = query($sql);
 if (!($id = $rs["arr"][0]["construct_id"])) break;
 case T_CONSTRUCT:
 dirt_linked_of_construct($id);
 break;
 case T_FOLDER:
 $dsonly = ($event != EVENT_ALL && ($event & EVENT_MOVE));
 dirt_linked_of_folder($id, $dsonly);
 break;
 case T_PAGE:
 dirt_linked_of_page($id);
 break;
 case T_TEMPLATE:
 dirt_linked_of_template($id);
 break;
 case CT_FILE:
 case T_IMAGE:
 dirt_linked_of_type(6,$id);
 dirt_linked_of_type(8,$id);
 break;
 case T_NODE:
 $sql = "SELECT id FROM folder WHERE node_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 dirt_linked_of_folder($val["id"]);
 }
 }
 break;
 default:
 warning(7, "cndirt::_dirtObject1: unknown dirt type ($type)");
 }
 }
}

?>
