<?php

Guifactory::setMainGui("main");
mysession_var_reg("DIC_USERTYPE");

mysession_var_reg("DIC_CMD");
mysession_var_reg("DIC_ID");
mysession_var_reg("DIC_SEARCH", true);

mysession_var_reg("DIC_LANGUAGES", true);


if ($cmd) $DIC_CMD = $cmd;

if ($id) $DIC_ID = $id;

if (!$DIC_CMD) $DIC_CMD = "search";

if ($DIC_CMD == "edit" && !$DIC_ID) $DIC_CMD = "new";

if ($newsearch) {
 $DIC_SEARCH = array();
 $DIC_SEARCH["info"] = "all";
}

if (!$DIC_LANGUAGES) {
 $DIC_LANGUAGES = array();

 $sql = "SELECT id, name FROM language";
 $rs = query($sql, 1);

 while(list($key,$val) = each($rs["arr"])) {
 $DIC_LANGUAGES[$val["id"]] = $val["name"];
 }
}

if (!$DIC_LANGUAGES[$METALANGUAGE_ID]) {
 $sql = "SELECT id, name FROM language WHERE id = ".sqlf_tl_num($METALANGUAGE_ID);
 $rs = query($sql);

 $DIC_LANGUAGES[$val["id"]] = $val["name"];
}


if ($DIC_CMD == "search") {
 
 $hi = array();

 $f = $HI["text"];
 $f["var"] = "searchtext";
 $f["label"] = i18n("Text");
 $f["optional"] = true;
 $hi[] = $f;

 $f = $HI["checkbox"];
 $f["var"] = "exactmatch";
 $f["label"] = i18n("exact Match");
 $hi[] = $f;
 
 
 $sql = "SELECT id, name FROM language";
 $rs = query($sql,1);
 $langs = $rs["arr"];
 
 $lst = array();
 $lst[0] = i18n("- All -");
 $lst["id"] = i18n("ID");
 reset($langs);
 while (list($key,$val) = each($langs)) {
 if (!$DIC_LANGUAGES[$val["id"]]) continue;
 $lst[$val["id"]] = $val["name"];
 }
 
 $f = $HI["sel"];
 $f["var"] = "field";
 $f["label"] = i18n("Field");
 $f["list"] = $lst;
 $f["optional"] = false;
 $f["force"] = false;
 $hi[] = $f;

 $lst = array();
 $lst[0] = i18n("- All -");
 $lst["full"] = i18n("Complete");
 $lst["part"] = i18n("Partial");
 $lst["new"] = i18n("New");
 reset($langs);
 while (list($key,$val) = each($langs)) {
 if (!$DIC_LANGUAGES[$val["id"]]) continue;
 $lst[$val["id"]] = i18n("Not in {0}",0,$val["name"]);
 }
 
 $f = $HI["sel"];
 $f["var"] = "state";
 $f["label"] = i18n("Translation");
 $f["list"] = $lst;
 $f["optional"] = false;
 $f["force"] = false;
 $hi[] = $f;
 
 $lst = array();
 $lst["all"] = i18n("- All -");
 if (is_array($DIC_TYPE)) {
 reset($DIC_TYPE);
 while (list($key,$val) = each($DIC_TYPE)) {
 $lst[$key] = $val;
 }
 }
 
 $f = $HI["sel"];
 $f["var"] = "_module";
 $f["label"] = i18n("Module");
 $f["list"] = $lst;
 $f["optional"] = false;
 $f["force"] = false;
 $hi[] = $f;

 $lst = array();
 $lst[0] = i18n("- All -");
 $lst[1] = i18n("Yes");
 $lst[2] = i18n("No");
 
 $f = $HI["sel"];
 $f["var"] = "used";
 $f["label"] = i18n("in use");
 $f["list"] = $lst;
 $f["optional"] = false;
 $f["force"] = false;
 $hi[] = $f;
 
 $f = $HI["ok"];
 $f["label"] = i18n("Search");
 $hi[] = $f;
 
 $f_search = new htmlform($hi,"dic_search");

 if (!$faction || !$f_search->issubmit) {
 
 $searchtext = $DIC_SEARCH["text"];
 $exactmatch = $DIC_SEARCH["exact"];
 $field = $DIC_SEARCH["field"];
 $state = $DIC_SEARCH["state"];
 $_module = $DIC_SEARCH["info"];
 $used = $DIC_SEARCH["enabled"];
 
 $f_search->load_script_vars();
 $faction = "";
 }

 if ($faction == "ok") {
 
 $DIC_SEARCH["text"] = $searchtext;
 $DIC_SEARCH["exact"] = $exactmatch;
 $DIC_SEARCH["field"] = $field;
 $DIC_SEARCH["state"] = $state;
 $DIC_SEARCH["info"] = $_module;
 $DIC_SEARCH["enabled"] = $used;
 }
}


if ($DIC_CMD == "new" || $DIC_CMD == "edit") {
 
 $hi = array();

 reset($DIC_LANGUAGES);
 while (list($key,$lang) = each($DIC_LANGUAGES)) {
 $f = $HI["ta"];
 $f["var"] = "lang$key";
 $f["label"] = $lang;
 $f["optional"] = ($key != $METALANGUAGE_ID);
 $f["cols"] = 32;
 $f["rows"] = 5;
 $hi[] = $f;
 }

 $f = $HI["checkbox"];
 $f["var"] = "forward";
 $f["label"] = i18n("go to next entry");
 $hi[] = $f;

 $f = $HI["checkbox"];
 $f["var"] = "enabled";
 $f["label"] = i18n("enabled");
 $hi[] = $f;

 $f = $HI["sel"];
 $f["var"] = "info";
 $f["label"] = i18n("Module");
 $f["list"] = $DIC_TYPE;
 $f["optional"] = false;
 $f["force"] = false;
 $hi[] = $f;

 if ($DIC_CMD == "edit") {
 $hi[] = $HI["prev"];
 $hi[] = $HI["next"];
 }

 $hi[] = $HI["ok"];
 $hi[] = $HI["reset"];
 $hi[] = $HI["cancel"];

 $f_edit = new htmlform($hi,"dic_edit");

 if (!$faction || !$f_edit->issubmit || $faction == "reset" || $faction == "next" || $faction == "prev") {
 if ($faction == "next") {
 

 }
 if ($faction == "prev") {
 

 }

 reset($DIC_LANGUAGES);
 while (list($key,$val) = each($DIC_LANGUAGES)) {
 ${"lang$key"} = "";
 }
 
 if ($DIC_CMD == "edit" && $DIC_ID) {
 if ($DIC_USERTYPE == 1) {
 $sql = "SELECT info, 1 AS enabled FROM outputuser WHERE id = ".sqlf_tl_num($DIC_ID);
 } else {
 $sql = "SELECT info, enabled FROM output WHERE id = ".sqlf_tl_num($DIC_ID);
 }
 $rs = query($sql);
 $info = $rs["arr"][0]["info"];
 $enabled = $rs["arr"][0]["enabled"];

 $dic = ($DIC_USERTYPE)?"dicuser":"dic";
 $db = ($DIC_USERTYPE)?$DB:getDicDBHandle();
 
 $sql = "SELECT value, language_id FROM ".sqlf_table($dic)." WHERE output_id = ".sqlf_tl_num(((int) $DIC_ID));
 $rs = query($sql, false, 0, $db);
 
 while (list($key,$val) = each($rs["arr"])) {
 if ($DIC_LANGUAGES[$val["language_id"]]) {
 ${"lang".$val["language_id"]} = $val["value"];
 }
 }
 } else {
 $info = 0;
 $enabled = 0;
 $DIC_ID = 0;
 }
 
 $forward = 1;
 
 $f_edit->load_script_vars();
 $faction = "";
 }
 
 if ($faction == "ok" && !$f_edit->err()) {
 $err = false;
 
 if ($DIC_CMD == "new") {
 $meta = ${"lang$METALANGUAGE_ID"};
 if (!$meta) {
 
 $err = true;
 
 } else {
 $id = i18n_create($meta, $info, $enabled, ($DIC_USERTYPE == 1));
 }
 
 if (is_false($id)) {
 

 $DIC_ID = 0;
 $err = true;
 } else if ($id) {
 $DIC_ID = $id;
 }
 } else {
 i18n_update($DIC_ID, $info, $enabled, ($DIC_USERTYPE == 1));
 }

 
 if (!$err) {
 reset($DIC_LANGUAGES);
 while (list($key,$val) = each($DIC_LANGUAGES)) {
 if ( !$key ) continue;
 $text = ${"lang$key"};
 
 if (!$text) {
 $rs = i18n_unset($DIC_ID, $key, ($DUC_USERTYPE == 1));
 } else {
 $rs = i18n_set($text, $DIC_ID, $key, ($DIC_USERTYPE == 1));
 }
 
 if ($rs) {
 $err = true;
 break;
 }
 }
 }

 i18n_clear_cache();

 if ($err) {
 
 
 } else {
 if ($DIC_CMD == "edit" && $forward) {
 
 
 }

 if ($DIC_CMD == "new") {
 if ($forward) {
 $DIC_ID = 0;
 $f_edit->clear();
 $cmd = "new";
 $REDO = $DO;
 } else {
 $DIC_CMD = "edit";
 }
 }
 }
 }

 
 if ($faction == "cancel") {
 $cmd = "search";
 $f_edit->clear();
 $REDO = $DO;
 }

 $NODERELATED[$DO][3]["icon"] = $ICO_DIC;
 $NODERELATED[$DO][3]["link"] = "$STAG&do=$DO&cmd=search";
 $NODERELATED[$DO][3]["text"] = i18n("Back to search");
 $NODERELATED[$DO][3]["help"] = "";
 $NODERELATED[$DO][3]["target"] = "list";
}

$ds = new ItemListDictionaryDataSource($DIC_LANGUAGES, $DIC_USERTYPE);
$ds->setExactMatch($DIC_SEARCH["exact"]);
$ds->setField($DIC_SEARCH["field"]);
$ds->setTranslation($DIC_SEARCH["state"]);
$ds->setModule($DIC_SEARCH["info"]);
$ds->setSearch($DIC_SEARCH["text"]);
$ds->setInUse($DIC_SEARCH["enabled"]);
$ds->setEditLink("$STAG&do=$DO&cmd=edit");

$list = new ItemList3("dic_search_list",$ds);
 
load_menu(836, $T_DICTYPEADMIN, 0);
?>
