<?php
node_include( "guifactory" );
node_include("usageinfo");
GUIFactory::setMainGui("main");
?>

Find pages with foreign links:
<form action="<?php echo "$STAG&do=$DO" ?>" method="post">
  <p>PageId:<input name="d_pageId" type="text" size="30" maxlength="30" /></p>
  <input type="hidden" name="d_cmd" value="pagewithoutforeignlink" />
</form>

<a href="<?php echo "$STAG&do=$DO" ?>&d_cmd=allforeignlinks">Find all foreign links</a> (This may take a long time and even might not work. MAY CAUSE HIGH SYSTEM LOAD )</br>

<?php
if($d_cmd=="pagewithoutforeignlink") {
 echo "Result: </br>";

 if(pageExists($d_pageId)) {
 findForeignLinks($d_pageId);
 }
 else {
 echo "Sorry i could not find the specified page with Id:" . $d_pageId . "</br>";
 }
} 
else if($d_cmd=="allforeignlinks") {
 findAllPagesWithoutForeignLinks();
}


function findAllPagesWithoutForeignLinks() {
 $sql = "select * from page";
 $rs = query($sql);

 
 foreach( $rs['arr'] as $row ) {
 findForeignLinks($row['id']);
 }

}

function findForeignLinks($spageId) {
$sql = "select * from page";
$rs = query($sql);

 $referenceFound = false;
 
 foreach( $rs['arr'] as $row ) {
 $linkedIds = getLinkedIds($row['id']);

 
 foreach($linkedIds[4] as $pageId) {
 if($spageId == $pageId) {
 $referenceFound = true;
 }
 }
 
 
 foreach($linkedIds[11] as $pageId) {
 if($spageId == $pageId) {
 $referenceFound = true;
 }
 } 
 }

 if($referenceFound==false) {
 echo "I could not find any pages that contain links to page with id: " . $spageId . "</br>";
 } 
 else {
 echo "I could find pages that contain links to page with id: " . $spageId . "</br>";
 }

}

echo "<hr>";
$sql = "select * from page";
$rs = query($sql);
echo "Searching deadlinks: </br>";
foreach( $rs['arr'] as $row ) {
 findDeadLinks($row["id"]);
}



echo "</br></br><hr></br>";


echo "Searching for links to foreign objects: </br>";
echo "<table border=0>";
echo "<tr><td><b>PageID</b></td><td><b>NodeID</b></td> <td> -> </td><td><b>ObjectType</b></td><td><b>ObjectID</b></td><td><b>Existing</b></td><td><b>NodeID</b></td> </tr>";
echo "<tr><td colspan=7><hr></td></tr>";
foreach( $rs['arr'] as $row ) {

findForeignNodeLinks($row["id"]);
}
echo "</table>";

function findForeignNodeLinks($pageId) {

 $linkedIds = getLinkedIds($pageId);

 foreach( $linkedIds[11] as $linkedPageId) {
 
 if($linkedPageId==0) {
 continue;
 }

 if(getNodeIdFromPage($linkedPageId) != getNodeIdFromPage($pageId)) {
 echo "<tr><td>" . $pageId . "</td><td>" . getNodeIdFromPage($pageId) ."</td><td> -> </td><td>Page</td><td>" . $linkedPageId . "</td><td>";
 echo pageExists($linkedPageId) ? "true" : "false";
 echo "</td><td>&nbsp;" . getNodeIdFromPage($linkedPageId) . "</td></tr>";
 }
 }

 foreach( $linkedIds[4] as $linkedPageId) {
 
 if($linkedPageId==0) {
 continue;
 }
 
 if(getNodeIdFromPage($linkedPageId) != getNodeIdFromPage($pageId)) {
 echo "<tr><td>" . $pageId . "</td><td>" . getNodeIdFromPage($pageId) ."</td><td> -> </td><td>Page</td><td>" . $linkedPageId . "</td><td>";
 echo pageExists($linkedPageId) ? "true" : "false";
 echo "</td><td>&nbsp;" . getNodeIdFromPage($linkedPageId) . "</td></tr>";
 }
 }

 foreach( $linkedIds[6] as $linkedContentFileId) {
 
 if($linkedContentFileId==0) {
 continue;
 }

 if(getNodeIdFromContentFile($linkedContentFileId) != getNodeIdFromPage($pageId)) {
 echo "<tr><td>" . $pageId . "</td><td>" . getNodeIdFromPage($pageId) ."</td><td> -> </td><td>Image (ContentFile)</td><td>" . $linkedContentFileId . "</td><td>";
 echo contentFileExists($linkedContentFileId) ? "true" : "false";
 echo "</td><td>&nbsp;" . getNodeIdFromContentFile($linkedContentFileId) . "</td></tr>";
 }
 }

 foreach( $linkedIds[8] as $linkedContentFileId) {
 
 if($linkedContentFileId==0) {
 continue;
 }

 if(getNodeIdFromContentFile($linkedContentFileId) != getNodeIdFromPage($pageId)) {
 echo "<tr><td>" . $pageId . "</td><td>" . getNodeIdFromPage($pageId) ."</td><td> -> </td><td>File (ContentFile)</td><td>" . $linkedContentFileId . "</td><td>";
 echo contentFileExists($linkedContentFileId) ? "true" : "false";
 echo "</td><td>&nbsp;" . getNodeIdFromContentFile($linkedContentFileId) . "</td></tr>";
 }
 }


 foreach( $linkedIds[25] as $linkedFolderId) {
 
 if($linkedFolderId==0) {
 continue;
 }
 
 if(getNodeIdFromFolder($linkedFolderId) != getNodeIdFromFolder($pageId)) {
 echo "<tr><td>" . $pageId . "</td><td>" . getNodeIdFromPage($pageId) ."</td><td>-></td><td>Folder</td><td>" . $linkedFolderId . "</td><td>";
 echo folderExists($linkedFolderId) ? "true" : "false"; 
 echo "</td><td>&nbsp;" . getNodeIdFromFolder($linkedFolderId) . "</td></tr>";
 }
 }
 
}

function findDeadLinks($pageId) {
 $linkedIds = getLinkedIds($pageId);

 foreach( $linkedIds[11] as $linkedPageId) {
 if( !pageExists($linkedPageId) && $linkedPageId != 0 ) {
 echo "<span style=\"color:red\">I found a dead link in page " . $pageId . " to page " . $linkedPageId . "</span></br>";
 }
 }

 foreach( $linkedIds[4] as $linkedPageId) {
 if( !pageExists($linkedPageId) && $linkedPageId != 0 ) {
 echo "<span style=\"color:red\">I found a dead link in page " . $pageId . " to page " . $linkedPageId . "</span></br>";
 }
 }

 foreach( $linkedIds[25] as $linkedFolderId) {
 if( !folderExists($linkedFolderId) && $linkedFolderId != 0 ) {
 echo "<span style=\"color:red\">I found a dead link in page " . $pageId . " to folder " . $linkedFolderId . "</span></br>";
 }
 }

 foreach( $linkedIds[6] as $linkedContentFileId) {
 if( !contentFileExists($linkedContentFileId) && $linkedContentFileId != 0 ) {
 echo "<span style=\"color:red\">I found a dead link in page " . $pageId . " to image (contentfile) " . $linkedContentFileId . "</span></br>";
 }
 }

 foreach( $linkedIds[8] as $linkedContentFileId) {
 if( !contentFileExists($linkedContentFileId) && $linkedContentFileId != 0 ) {
 echo "<span style=\"color:red\">I found a dead link in page " . $pageId . " to file (contentfile) " . $linkedContentFileId . "</span></br>";
 }
 }

}

function folderExists($folderId) {
 $sql = "select count(*) from folder where id = " . sqlf_tl_num($folderId);
 $rs = query($sql);
 if( $rs['arr'][0][0] == 0) {
 return false;
 }
 else if($rs['arr'][0][0]==1) {
 return true;
 }
 else {
 echo "Data Inconsitency found for folder " . $folderId . "</br>";
 }
}

function contentFileExists($fileId) {
 $sql = "select count(*) from contentfile where id = " . sqlf_tl_num($fileId);
 $rs = query($sql);
 if( $rs['arr'][0][0] == 0) {
 return false;
 }
 else if($rs['arr'][0][0] == 1) {
 return true;
 }
 else {
 echo "Data Inconsitency found for contentfile " . $fileId . "</br>";
 }
}

function pageExists($pageId) {
 $sql = "select count(*) from page where id = " . sqlf_tl_num($pageId);
 $rs = query($sql);
 if( $rs['arr'][0][0] == 0) {
 return false;
 }
 else if($rs['arr'][0][0] == 1) {
 return true;
 }
 else {
 echo "Data Inconsitency found for page" . $pageId . "</br>";
 }
}

function getNodeIdFromContentFile($contentFileId) {
 $sql = "select node_id from contentfile c inner join folder on c.folder_id = folder.id and c.id = " . sqlf_tl_num($contentFileId);
 $rs = query($sql);
 return $rs['arr'][0]['node_id'];
}

function getNodeIdFromFolder($folderId) {
 $sql = "select node_id from folder where id = ". sqlf_tl_num($folderId);
 $rs = query($sql);
 return $rs['arr'][0]['node_id'];
}


function getNodeIdFromPage($pageId) {
 $sql = "select folder.node_id from page inner join folder on page.folder_id = folder.id and page.id = " . sqlf_tl_num($pageId) ;
 $rs = query($sql);
 return $rs['arr'][0]['node_id'];
}


function getLinkedIds($pageId) {
 $sql = "select part.type_id,type.name,value.value_ref from page inner join contenttag c on c.content_id = page.content_id and page.id = " . sqlf_tl_num($pageId) . " inner join value on value.contenttag_id = c.id inner join part on value.part_id = part.id inner join type on part.type_id = type.id where ( type.name like '%URL%' or type.name like '%page%' )";
 $rs = query($sql);

 foreach( $rs['arr'] as $row ) {
 $linkedIds[ $row["type_id"] ][ $row["value_ref"] ] = $row["value_ref"];
 }
 return $linkedIds;
}

?>
