<?php
 header("HTTP/1.1 $code $code_message");
 header("Content-Type: text/xml");
 $charset = $FEATURE["UTF8"] ? "UTF-8" : "ISO-8859-1";
 echo "<?xml version=\"1.0\"?>\n";
?>
<response>
  <code><?php echo htmlentities($code, ENT_COMPAT, $charset) ?></code>
  <message><?php echo htmlentities($message, ENT_COMPAT, $charset) ?></message>
<?php if ($job) { ?>
  <job id="<?php echo $id ?>">
    <status><?php echo htmlentities($status, ENT_COMPAT, $charset) ?></status>
    <name><?php echo htmlentities($job->getValue("name"), ENT_COMPAT, $charset) ?></name>
    <description><?php echo htmlentities($job->getValue("description"), ENT_COMPAT, $charset) ?></description>
    <creator><?php echo htmlentities($creator->format($job->d_values), ENT_COMPAT, $charset) ?></creator>
    <created><?php echo htmlentities($created->format($job->d_values), ENT_COMPAT, $charset) ?></created>
    <editor><?php echo htmlentities($editor->format($job->d_values), ENT_COMPAT, $charset) ?></editor>
    <edited><?php echo htmlentities($edited->format($job->d_values), ENT_COMPAT, $charset) ?></edited>
    <lastrun><?php echo htmlentities($lastrun_time, ENT_COMPAT, $charset) ?></lastrun>
    <lastrun_status><?php echo htmlentities($lastrun_status, ENT_COMPAT, $charset) ?></lastrun_status>
    <lastrun_duration><?php echo htmlentities($lastrun_duration, ENT_COMPAT, $charset) ?></lastrun_duration>
    <runs><?php echo htmlentities($runs, ENT_COMPAT, $charset) ?></runs>
    <average_duration><?php echo htmlentities($average, ENT_COMPAT, $charset) ?></average_duration>
  </job>
<?php } ?>
</response>
<?php 





if ($SID && $login) {
 mysession_logout($SID);
}

die(); ?>
