#!/bin/sh
# usage: ./update.sh /Node/.node

# we need the command's exit status if it fails
docmd() {
  if ! $* ; then
    exit $?
  fi
}

if [ "x$1" = "x" ]; then
  p="/Node/.node"
else
  p=$1
fi
docmd rm -Rf "$p"_old
docmd mv "$p" "$p"_old
docmd mv $PWD "$p"

# change group to node_public, if node user is member of this group
groups | grep -q '\bnode_public\b'
if [ "$?" = "0" ]; then
	docmd chgrp -R node_public "$p"
fi

docmd chmod -R 750 "$p"
docmd rm "$p"/update.sh
