<?php


if ($_REQUEST['casredirecturl']) {
 $_SERVER['REQUEST_URI'] = $_REQUEST['casredirecturl'];
}

function initCas() {
 global $CAS_SSO;

 

 $casconfigexample = "
\$CAS_SSO = array(
  'protocol' => 'https',
  'host' => '10.43.93.252',
  'port' => '8443',
  'path' => 'cas-server-webapp-3.3.3',

  'groupMapper' => 'mapCasGroups',
);
";
 if (!$CAS_SSO) {
 return;
 }
 $requiredattrs = array(
 'protocol' => 'http or https.',
 'host' => 'Host name to CAS server',
 'port' => 'Port number for HTTPS port of CAS Server.',
 'path' => 'Path to CAS web application.',
 'groupMapper' => 'Function name which gets passed in the attributes of the current user.',
 );
 foreach( $requiredattrs as $attkey => $attdesc ) {
 if( !$CAS_SSO[$attkey] ) {
 halt(7, "Missing attribute for CAS_SSO config. $attkey: $attdesc");
 }
 }

 
 $CAS_SSO['url'] = $CAS_SSO['protocol'] . '://' . $CAS_SSO['host'] . ':' . $CAS_SSO['port'] . '/' . $CAS_SSO['path'];

 phpCAS::setDebug('/Node/tmp/cas.log');
 phpCAS::client(CAS_VERSION_2_0,$CAS_SSO['host'],$CAS_SSO['port'],$CAS_SSO['path']);
 global $PHPCAS_CLIENT;
 $PHPCAS_CLIENT->setServerSchema($CAS_SSO['protocol']);

 
 phpCAS::setNoCasServerValidation();
 phpCAS::handleLogoutRequests();

}
initCas();

?>
