<?php
GUIFactory::setMainGUI( "main" );

$cgs = get_contentgroups($folder_info["node_id"]);

$hi = Array();

$lang = array();
$langCodes = ""; 
foreach($cgs as $cgkey => $cgvalue) {
 $lang[$cgkey] = $cgvalue["name"];
 $langCodes .= $cgvalue["code"] . "|";
}

$langCodes = substr($langCodes,0,strlen($langCodes)-1);
$tmp = $HI["sel"];
$tmp["list"] = $lang;
$tmp["var"] = "lang";
$tmp["label"] = i18n("language");
$hi[] = $tmp;

$hi[] = $HI["ok"];
$hi[] = $HI["cancel"];

$f = new htmlform($hi,"page");


if ($faction == "ok" && !$f->err()) {
 while (list($key) = each($PAGES_TO_SET_CG)) {
 cmd_page_checkandfixcs($key);
 $page = get_pageinfo($key);
 
 $sql = "select count(*) as c from page where contentset_id = ".sqlf_tl_num($page["contentset_id"])." and contentgroup_id = ".sqlf_tl_num($lang);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {

 
 
 $sql = "SELECT id FROM page WHERE channelset_id = " .sqlf_tl_num($page["channelset_id"]);
 $rs = query($sql);
 foreach ($rs["arr"] as $arr) {
 $pageId = $arr["id"];
 $page = get_pageinfo($pageId);
 $sql = "UPDATE page SET contentgroup_id = " . sqlf_tl_num($lang) . ", status = 0 WHERE id = " . sqlf_tl_num($pageId);
 query($sql); 
 updatePageFilenameLang($page, $lang, $cgs, $langCodes);

 
 if ($FEATURE["javaparser"]) {
 $javaParser = & CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGE, $pageId);
 }
 }
 }
 }
 $REDO = 13020;
 mysession_var_unreg("PAGES_TO_SET_CG");
}
if ($faction == "cancel") {
 $REDO = 13020;
 mysession_var_unreg("PAGES_TO_SET_CG");
}



function updatePageFilenameLang($page, $cgId, $cgs, $langCodes) {
 global $FEATURE;

 $nameParts = explode(".", $page["filename"]);
 $count = count($nameParts);
 $langAdded = false;

 if ($count < 2) {
 
 return;
 }

 if ($FEATURE["contentgroup3_pagefilename"]) {
 foreach ($nameParts as $nr => $part) {
 
 if (preg_match("/^($langCodes)\$/", $part)) {
 $nameParts[$nr] = $cgs[$cgId]["code"];
 $langAdded = true;
 }
 }

 
 if (!$langAdded) {
 $nameParts[$count] = $nameParts[$count - 1]; 
 $nameParts[$count - 1] = $cgs[$cgId]["code"];
 }

 $newName = implode(".", $nameParts);
 query("UPDATE page SET filename = '".sqlf_escaped($newName)."' WHERE id = " . sqlf_tl_num($page["id"])); 
 }
}
