<?php

class CNPartTypeFactory extends BaseObject {

 function getPartTypes() {
 return array(1,2,3,4,5,6,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25);
 }

 function &getPartType($typeid) {
 node_include("cnparttype");
 switch ($typeid) {
 case 1: $obj = new CNTextPartType(); break;
 case 2: $obj = new CNTextHtmlPartType(); break;
 case 3: $obj = new CNHtmlPartType(); break;
 case 4: $obj = new CNUrlPagePartType(); break;
 case 5: $obj = new CNTagGlobalPartType(); break;
 case 6: $obj = new CNUrlImagePartType(); break;
 case 8: $obj = new CNUrlFilePartType(); break;
 case 9: $obj = new CNTextShortPartType(); break;
 case 10: $obj = new CNTextHtmlLongPartType(); break;
 case 11: $obj = new CNTagPagePartType(); break;
 case 12: $obj = new CNTablePartType(); break;
 case 13: $obj = new CNOverviewPartType(); break;
 case 14: $obj = new CNUrlFileEncPartType(); break;
 case 15: $obj = new CNListPartType(); break;
 case 16: $obj = new CNListUnsortedPartType(); break;
 case 17: $obj = new CNListSortedPartType(); break;
 case 18: $obj = new CNSelectImgHeightPartType(); break;
 case 19: $obj = new CNSelectImgWidthPartType(); break;
 case 20: $obj = new CNTagTemplatePartType(); break;
 case 21: $obj = new CNHtmlLongPartType(); break;
 case 22: $obj = new CNFileLocalpathPartType(); break;
 case 23: $obj = new CNTableExtPartType(); break;
 case 24: $obj = new CNSelectClassPartType(); break;
 case 25: $obj = new CNUrlFolderPartType(); break;
 case 26: $obj = new CNJavaEditorPartType(); break;
 case 27: $obj = new CNDHtmlEditorPartType(); break;
 case 29: $obj = new CNSelectSinglePartType(); break;
 case 30: $obj = new CNSelectMultiplePartType(); break;
 case 31: $obj = new CNCheckboxPartType(); break;
 case 32: $obj = new CNDataSourcePartType(); break;
 }
 return $obj;
 }

}


class CNPartFactory extends BaseObject {

 function &getPart($id) {
 static $parts;
 if (!is_object($parts[$id])) {
 $parts[$id] = new CNPartObject($id);
 }
 return $parts[$id];
 }
}

class CNConstructFactory extends BaseObject {

 function &getConstruct($id) {
 static $constructs;
 if (!is_object($constructs[$id])) {
 $constructs[$id] = new CNConstruct($id);
 }
 return $constructs[$id];
 }

}

?>
