<?php










function get_translation($pageId, $contentgroupId, $channelId, $keepLocked = true) {
 global $NODE_ID, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 $contentgroups = get_contentgroups($NODE_ID);
 $languageCode = $contentgroups[$contentgroupId]["code"];

 $fc = new fetchCurl();

 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/translate/$pageId?sid=$SESSION_TOKEN&language=" .
 $languageCode . "&channelId=$channelId&locked=$unlock";

 $request = array();
 $fc->setSubmitType("POST");
 $fc->setPostData(json_encode($request));
 $fc->setHeader("Content-Type", "application/json");

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7, 'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error ' . $fc->getReturnCode());
 }

 $response = json_decode($json, true);

 if ($response["responseInfo"]["responseCode"] === "OK") {
 return $response["page"];
 } else {
 
 return false;
 }
}

?>
