<?php

node_include("tree");
node_include("T_TYPE");
function getTaskJobMenu()
{
 global $DIC, $STAG, $LOADEDMENU, $USER_ID, $T_TASKADMIN;
 $menu_job_name = i18n('sn_task_date');
 $mnu_job = array( "", $menu_job_name, "$STAG", "list", "mnuuser", "l" );
 $mnu_job_edit = array( $menu_job_name, i18n( "Edit" ), "$STAG&do=871&id=".$LOADEDMENU["o_id"], "list", "", 0 );
 $mnu_job_details = array( $menu_job_name, i18n( "Details" ), "$STAG&do=873&id=".$LOADEDMENU["o_id"], "list", "", 0 );

 $perms = perm( $USER_ID, $T_TASKADMIN );
 $MENU[] = $mnu_job;
 if ( $perms[13] )
 $MENU[] = $mnu_job_edit;
 $MENU[] = $mnu_job_details;
 return $MENU;
}

function getTaskNewMenu()
{
 global $DIC, $STAG, $ICO_USER, $ICO_TREEMENU, $ICO_TASK, $ICO_TASK_TEMPLATE, $ICO_JOB;
 global $USER_ID, $T_TASKADMIN;
 $menu_new_name = i18n('new');
 $mnu_new = array( "", $menu_new_name, "$STAG", "list", "mnuuser", "l" );
 $mnu_new_templates = array( $menu_new_name, i18n('sn_task_template'), "$STAG&do=851", "list", "", 0, $ICO_TASK_TEMPLATE );
 $mnu_new_tasks = array( $menu_new_name, i18n('sn_task'), "$STAG&do=863", "list", "", 0, $ICO_TASK );
 $mnu_new_task_schedule = array( $menu_new_name, i18n('sn_task_date'), "$STAG&do=871", "list", "", 0, $ICO_JOB );

 $add = array();
 $MENU[] = $mnu_new;
 $perms = perm( $USER_ID, $T_TASKADMIN );
 if ( $perms[9] )
 $add[] = $mnu_new_templates;
 if ( $perms[11] )
 $add[] = $mnu_new_tasks;
 if ( $perms[13] )
 $add[] = $mnu_new_task_schedule;
 if ( count($add) )
 return array_merge( $MENU, $add );
 return array();
}

function getTaskViewMenu()
{
 global $DIC, $STAG, $ICO_USER, $ICO_TREEMENU, $ICO_TASK_TEMPLATE, $ICO_TASK, $ICO_JOB;
 global $USER_ID, $T_TASKADMIN;
 $menu_view_name = i18n('menu_view');
 $mnu_view = array( "", $menu_view_name, "$STAG", "list", "mnuuser", "l" );
 $mnu_view_templates = array( $menu_view_name, i18n('sn_task_templates'), "$STAG&do=850", "list", "", 0, $ICO_TASK_TEMPLATE );
 $mnu_view_tasks = array( $menu_view_name, i18n('sn_tasks'), "$STAG&do=860", "list", "", 0, $ICO_TASK );
 $mnu_view_task_schedule = array( $menu_view_name, i18n('sn_task_dates'), "$STAG&do=870", "list", "", 0, $ICO_JOB );

 $add = array();
 $MENU[] = $mnu_view;
 $perms = perm( $USER_ID, $T_TASKADMIN );
 
 $tasks = tree_get_subfolders(T_TASK_GROUP, T_TASK_GROUP);
 $jobs = tree_get_subfolders(T_JOB_GROUP, T_JOB_GROUP);
 $tasktemplates = tree_get_subfolders(T_TASK_TEMPLATE_GROUP, T_TASK_TEMPLATE_GROUP);
 
 if ( $perms[8] || $tasktemplates)
 $add[] = $mnu_view_templates;
 if ( $perms[10] || $tasks)
 $add[] = $mnu_view_tasks;
 if ( $perms[12] || $jobs )
 $add[] = $mnu_view_task_schedule;
 if ( count($add) )
 return array_merge( $MENU, $add );
 return array();
}

function getTaskRelated($do) {
 
 global $USER_ID, $T_TASKADMIN, $ICO_TASK, $ICO_TASK_TEMPLATE, $ICO_JOB, $DIC, $STAG;
 
 $related_viewtasktemplates["icon"] = $ICO_TASK_TEMPLATE;
 $related_viewtasktemplates["link"] = "$STAG&do=850";
 $related_viewtasktemplates["text"] = i18n('sn_task_templates');
 $related_viewtasktemplates["help"] = "";
 $related_viewtasktemplates["target"] = "list";
 $related_viewtasktemplates["perms"] = array("t_type"=>$T_TASKADMIN, "o_id"=>NULL, "bit"=>8);

 $related_viewtasks["icon"] = $ICO_TASK;
 $related_viewtasks["link"] = "$STAG&do=860";
 $related_viewtasks["text"] = i18n('sn_tasks');
 $related_viewtasks["help"] = "";
 $related_viewtasks["target"] = "list";
 $related_viewtasks["perms"] = array("t_type"=>$T_TASKADMIN, "o_id"=>NULL, "bit"=>8);

 $related_viewjobs["icon"] = $ICO_JOB;
 $related_viewjobs["link"] = "$STAG&do=870";
 $related_viewjobs["text"] = i18n('sn_task_dates');
 $related_viewjobs["help"] = "";
 $related_viewjobs["target"] = "list";
 $related_viewjobs["perms"] = array("t_type"=>$T_TASKADMIN, "o_id"=>NULL, "bit"=>8);

 $perms = perm( $USER_ID, $T_TASKADMIN );
 
 $tasks = tree_get_subfolders(T_TASK_GROUP, T_TASK_GROUP);
 $jobs = tree_get_subfolders(T_JOB_GROUP, T_JOB_GROUP);
 $tasktemplates = tree_get_subfolders(T_TASK_TEMPLATE_GROUP, T_TASK_TEMPLATE_GROUP);
 
 $related = array();
 if ( ($perms[8] || $tasktemplates) && in_array($do, array(860)) ) {
 $related[] = $related_viewtasktemplates;
 }
 if ( ($perms[10] || $tasks) && in_array($do, array(870,850,873,874)) ) {
 $related[] = $related_viewtasks;
 }
 if ( ($perms[12] || $jobs) && in_array($do, array(860,850,873,874)) ) {
 $related[] = $related_viewjobs;
 }
 
 return $related;
}

function& initSelector( $paramType, $label="" )
{
 global $T_CONTENT, $T_FOLDER, $T_NODE, $T_DOMAIN_CHANNEL;
 
 switch ( $paramType )
 {
 case 1:
 node_class( "cnnodeobject" );
 node_class( "minibrowserhiselector" );
 node_class( "minibrowsersimpletree" );
 $wrapper = new MinibrowserSimpleTree( 1, $T_CONTENT );
 $wrapper->setTType( $T_NODE, new CNFolderNodeObject() );
 $wrapper->setTType( $T_DOMAIN_CHANNEL, new CNFolderNodeObject() );
 return new MinibrowserHiSelector( $wrapper, $label ); 
 break;
 case 2:
 node_class( "cnfolderobject" );
 node_class( "minibrowserhiselector" );
 node_class( "minibrowsersimpletree" );
 $wrapper = new MinibrowserSimpleTree( 1, $T_CONTENT );
 $wrapper->setTType( $T_FOLDER, new CNFolderObject() );
 $wrapper->setTType( $T_NODE, new CNFolderNodeObject() );
 return new MinibrowserHiSelector( $wrapper, $label ); 
 break;
 case 3:
 node_class( "textcomponent" );
 return new TextComponent($label,true);
 break;
 case 4:
 node_class( "pageselector" );
 node_class( "minibrowserhiselector" );
 node_class( "minibrowsersimpletree" );
 $wrapper = new PageSelector( 0, 0, 0 );
 return new MinibrowserHiSelector( $wrapper, $label ); 
 break;
 default:
 halt( 7, "initSelector: unknown paramType($paramType)" );
 }
}





function findNonDupSeperator( $str, $sep, $start )
{
 $strlen = strlen( $str );
 $pos = strpos( $str, $sep, $start );
 while ( $pos < $strlen && $pos !== false )
 {
 if ( $pos == 0 )
 return $pos;
 if ( substr( $str, $pos-1, 1 ) != "\\" )
 {
 return $pos;
 }
 else
 $pos = strpos( $str, $sep, $pos+2 );
 }
 return false;
}

function findCommandParams( $command )
{
 $params = array();
 
 $start = findNonDupSeperator( $command, "%", 0 );
 while ( $start !== false )
 {
 $end = findNonDupSeperator( $command, "%", $start+1 );
 if ( $end === false )
 return $params;
 $p = substr( $command, $start+1, $end - $start - 1 );
 $pos = strpos( $p, "." );
 if ( $pos !== false )
 {
 $name = substr( $p, 0, $pos );
 $property = substr( $p, $pos+1 );
 }
 else
 {
 $name = $p;
 $property = "";
 }

 if ( !isset($params[$name]) )
 $params[$name] = array();
 $params[$name][] = $property;
 $start = findNonDupSeperator( $command, "%", $end+1 );
 }
 
 return $params;
}

 function bindCommandParams( $command, $params )
 {
 $cParams = array_keys(findCommandParams($command));
 $ret = array();
 $hash = array();
 foreach ( $params as $param )
 {
 $hash[$param->getValue( "name" )] = $param;
 }
 
 foreach ( $cParams as $key )
 {
 $ret[$key] = $hash[$key];
 }
 return $ret;
 }

 function hashParams( &$params )
 {
 $hash = array();
 foreach ( $params as $key=>$param )
 {
 
 
 $tplParam = $param["tasktemplateparam"];
 $pName = $tplParam->getValue("name");
 $taskParam = $param["taskparam"];
 
 
 unset( $selector );
 if ( !isset( $hash[$pName] ) ) 
 {
 $selector =& initSelector( $tplParam->getValue("paramtype"), $pName );
 $hash[$pName] = &$selector; 
 }
 else 
 {
 $selector =& $hash[$pName]; 
 }
 
 if ( is_a( $selector, "collectioncomponent" ) )
 {
 $result = &resolvePropertyObject($taskParam->getValue("name"), $selector);
 unset( $comp );
 $comp = &$result["obj"];
 $fieldName = $result["prop"];
 }
 else 
 {
 unset( $comp );
 $comp = &$selector; 
 $fieldName = $taskParam->getValue("name");
 }
 
 $cValue = $taskParam->getValue("value");
 $comp->setFieldValue( $fieldName, $cValue);
 }
 
 foreach ( $hash as $key=>$val )
 {
 $hash[$key]->onLoadFinished();
 }
 return $hash;
 }

 









 function dispatchCommand( &$task, &$template, &$params )
 {
 node_include( "resolveproperty" );
 
 
 $hash = hashParams( $params );
 
 $command = $template->getValue( "command" );
 $cParams = findCommandParams( $command );
 $resolved = array();
 
 foreach ( $cParams as $name=>$properties )
 {
 foreach ( $properties as $property )
 {
 $key = $property?($name.".".$property):$name;
 $prop = resolveProperty( $property, $hash[$name] );
 if ( is_a( $prop, "baseobject" ) && !is_a( $prop, "nodeexception" ) )
 $resolved[$key] = $prop->toString();
 else
 $resolved[$key] = "";
 }
 }
 
 foreach ( $resolved as $key=>$value )
 {
 $command = str_replace( "%".$key."%", $value, $command );
 }
 
 $command = str_replace( "\%", "%", $command );
 return $command;
 }

 







 function translateCommand( $taskId )
 {
 $taskJoinTable = new SqlJoinTable(
 array( new SqlTable("taskparam"), new SqlTable("tasktemplateparam") ),
 array( "tasktemplateparam.id=taskparam.templateparam_id" )
 );
 $params = $taskJoinTable->findBy( "taskparam.task_id", $taskId );
 
 $taskTable = new SqlJoinTable( 
 array( new SqlTable("task"), new SqlTable("tasktemplate") ),
 array( "task.tasktemplate_id=tasktemplate.id" )
 );
 $tasks = $taskTable->findBy( "task.id", $taskId );
 if ( !count($tasks) )
 return "Invalid task id($taskId)";
 return dispatchCommand( $tasks[0]["task"], $tasks[0]["tasktemplate"], $params );
 }




 define ( "JOBSTATUS_INACTIVE", 1 ); 
 define ( "JOBSTATUS_WAITING", 2 ); 
 define ( "JOBSTATUS_RUNNING", 3 ); 
 define ( "JOBSTATUS_DONE", 4 ); 
 define ( "JOBSTATUS_DUE", 5 ); 
 define ( "JOBSTATUS_INACTIVE_RUNNING", 6 ); 
 define ( "JOBSTATUS_INVALID", 7 ); 

 function translateJobStatus( $status )
 {
 global $DIC;
 switch ( $status )
 {
 case JOBSTATUS_INACTIVE:
 return i18n('sn_jobstatus_inactive');
 case JOBSTATUS_WAITING:
 return i18n('sn_jobstatus_waiting');
 case JOBSTATUS_RUNNING:
 return i18n('sn_jobstatus_running');
 case JOBSTATUS_DONE:
 return i18n('sn_jobstatus_done');
 case JOBSTATUS_DUE:
 return i18n('sn_jobstatus_due');
 case JOBSTATUS_INACTIVE_RUNNING:
 return i18n('sn_jobstatus_inactive_running');
 case JOBSTATUS_INVALID:
 return i18n( "Invalid" );
 default:
 return i18n('sn_jobstatus_na');
 }
 }
 
 function getJobStatus( &$job, $jobRunTable=false, $previousJobs=array() )
 {
 global $scheduleTypeClasses, $MAX_SCHEDULE_RUNTIME, $FEATURE;
 
 if ( in_array( $job->getValue( "id" ), $previousJobs ) ) {
 return JOBSTATUS_INVALID;
 }
 
 if ( $jobRunTable === false )
 {
 node_class( "sqltable" );
 $jobRunTable = new SqlTable( "jobrun" );
 }
 
 
 $runs = $jobRunTable->findBy( array("job_id", "valid"), 
 array($job->getValue("id"),1), "=", "starttime DESC", 1 );
 if ( count( $runs ) ) 
 {
 $lastRunRow = $runs[0];
 if ( $lastRunRow->getValue( "endtime" ) == 0 )
 {
 if ( $lastRunRow->getValue( "starttime" ) + $MAX_SCHEDULE_RUNTIME > time() )
 {
 return ($job->getValue( "status" ))?JOBSTATUS_RUNNING:JOBSTATUS_INACTIVE_RUNNING;
 }
 else 
 {
 $lastRunRow->setValue( "valid", 0 );
 $lastRunRow->save();
 } 
 }
 else
 $lastRun = $lastRunRow->getValue( "starttime" );
 }
 else 
 {
 $lastRun = 0;
 }

 if( !$FEATURE['task_schedule_ignore_processlogger'] ) {
 
 
 $logger = new ProcessLogger( "scheduler_task_" . $job->getValue("id") );
 if( $logger->isRunning( $MAX_SCHEDULE_RUNTIME ) ) {
 return ($job->getValue( "status" ))?JOBSTATUS_RUNNING:JOBSTATUS_INACTIVE_RUNNING;
 }
 }

 
 if ( $job->getValue( "status" ) == JOBSTATUS_INACTIVE )
 {
 
 $schedule = $scheduleTypeClasses[$job->getValue( "schedule_type" )];
 $schedule->loadData( node_unserialize($job->getValue("schedule_data")) );
 if ( $schedule->isDue( time(), $lastRun, $job->getValue("id"), $previousJobs ) )
 return JOBSTATUS_DUE;
 else if( $schedule->isDone( time(), $lastRun, $job->getValue("id"), $previousJobs ) )
 return JOBSTATUS_DONE;
 return JOBSTATUS_WAITING;
 }
 return JOBSTATUS_INACTIVE;
 }


 
 
 function spawnNewScheduler( $cmd = FALSE, $job_id = FALSE ) {
 global $SCHEDULER_SPAWN_JOB_CMD, $CONFIGFILE, $SCHEDULER_LOG, $SCHEDULER_CMD_PREFIX, $SCHEDULER_PIPE;
 if( !$SCHEDULER_SPAWN_JOB_CMD ) {
 $spawnjobcmd = $GLOBALS['PHP_PATH'] . " /Node/.node/sh.php";
 } else {
 $spawnjobcmd = $SCHEDULER_SPAWN_JOB_CMD;
 }
 if( !$SCHEDULER_LOG ) {
 $schedulerlog = "/Node/node/log/scheduler.log";
 } else {
 $schedulerlog = $SCHEDULER_LOG;
 }
 if( !$SCHEDULER_PIPE ) {
 $schedulerpipe = ">> $schedulerlog 2>&1";
 } else {
 $schedulerpipe = $SCHEDULER_PIPE;
 }
 if (!$SCHEDULER_CMD_PREFIX && strtoupper(substr(PHP_OS, 0, 3)) !== 'WIN') {
 $cmdprefix = "nohup";
 } else {
 $cmdprefix = $SCHEDULER_CMD_PREFIX;
 }
 $runcmd = "$cmdprefix $spawnjobcmd do=880 CONFIGFILE=$CONFIGFILE";
 if ( $runcmd !== FALSE ) { $runcmd .= " cmd=$cmd job_id=$job_id"; }

 if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
 $command = $runcmd . " $schedulerpipe";
 exec($command);
 } else {
 
 
 exec( "echo ". escapeshellarg($runcmd)." |sh $schedulerpipe &");
 }
 }
